<?php
/*********************************************************************************************
 * e107 PLUGIN: Auto Gallery
 * VERSION:     2.xx
 * DESCRIPTION: A media/image gallery, where galleries are based on a directory structure. 
 *              Thumbnails are automatically generated through Imagemagick or GD.
 * WRITTEN BY:  Mr_Visible (www.cerebralsynergy.com)
 * DATE:        11/04/2007
 *
 * Released under the terms and conditions of the
 * GNU General Public License (http://gnu.org).
 ********************************************************************************************/

require_once(dirname(__FILE__)."/def.php");
require_once(dirname(__FILE__)."/language.php");
require_once(e_HANDLER."userclass_class.php");

if (file_exists(AUTOGAL_LANGDIR."/".e_LANGUAGE."_Admin.php"))
{
	require_once(AUTOGAL_LANGDIR."/".e_LANGUAGE."_Admin.php");
}
else
{
	require_once(AUTOGAL_LANGDIR."/English_Admin.php");
}
require_once(dirname(__FILE__)."/../../class2.php");

function AutoGal_ShowAdmin($element, $ns, $eleInfo=NULL)
{
	global $g_startImage;
	global $g_isAdmin;
	
	if ($eleInfo == NULL) $eleInfo = AutoGal_GetElementInfo($element, true);
	if (!$g_isAdmin) return;
	
	$filePerms = fileperms($eleInfo['abspath']);
	$filePermsNum = substr(sprintf('%o', $filePerms), -3);
	$filePermsStr = AutoGal_FormatFilePerms($filePerms) . " ($filePermsNum)";
	if (!AUTOGAL_CHMODWARNOFF)
	{
		if (($eleInfo['type'] == 'Gallery')&&($filePermsNum != AUTOGAL_PERMSGALDIR))
		{
			$filePerms .= " <font color='red'>".AUTOGAL_LANG_ADMIN_FUNCTIONS_L1." ".AUTOGAL_PERMSGALDIR."!</font>";
		}
	}
	
	if ($uploadPerms = IsBadUploadDirPerms()) $ns -> tablerender(AUTOGAL_LANG_ADMIN_FUNCTIONS_L2, $uploadPerms); 
	
	$viewXML = "[<a href=\"".AUTOGAL_SHOWXML."?file=".rawurlencode($element)."\">view</a>]";
		
	$text = "
	<div style='text-align:center'>
	<table class='border'>
	<tr>
        <td class='forumheader3'><b>".AUTOGAL_LANG_ADMIN_FUNCTIONS_L3."</b></td>
        <td class='forumheader3' colspan='2'>$filePermsStr</td>         
    </tr>
	<tr>
		<td class='forumheader3'><b>".AUTOGAL_LANG_ADMIN_FUNCTIONS_L36."</b></td>
        <td class='forumheader3' colspan='2'>".
			($eleInfo['xmlok'] ? AUTOGAL_LANG_ADMIN_FUNCTIONS_L34." $viewXML" : ($eleInfo['xmlerror'] ? "<font color='red'>".AUTOGAL_LANG_ADMIN_FUNCTIONS_L37."</font> ".$eleInfo['xmlerror']." $viewXML" : AUTOGAL_LANG_ADMIN_FUNCTIONS_L38))."
		</td>         
	</tr>
	".($eleInfo['type'] == "Gallery" ? "
	<tr>
		<td class='forumheader3'><b>".AUTOGAL_LANG_MENU_L1."</b></td>
		<td class='forumheader3'>
			<select name='ag_adminselection' id='ag_adminselection' class='tbox'>
			<option value='current'>".str_replace('[TYPE]', $eleInfo['filetypetitle'], str_replace('[TITLE]', $eleInfo['title'], AUTOGAL_LANG_MENU_L2))."</option>
			<option value='checked'>".AUTOGAL_LANG_MENU_L3."</option>
			<option value='unchecked'>".AUTOGAL_LANG_MENU_L4."</option>
			<option value='all'>".AUTOGAL_LANG_MENU_L5."</option>
			<option value='galleries'>".AUTOGAL_LANG_MENU_L15."</option>
			<option value='files'>".AUTOGAL_LANG_MENU_L16."</option>
			</select>
		</td>
	</tr>" : '')."
	<tr>
		<td class='forumheader3'><b>".AUTOGAL_LANG_MENU_L6."</b></td>
		<td class='forumheader3'>
			<select name='ag_adminaction' id='ag_adminaction' class='tbox'>
			<option value='rename'>".AUTOGAL_LANG_MENU_L7."</option>
			<option value='delete'>".AUTOGAL_LANG_MENU_L8."</option>
			<option value='move'>".AUTOGAL_LANG_MENU_L9."</option>
			".(!$eleInfo['isnonimg'] ? "<option value='watermark'>".AUTOGAL_LANG_MENU_L17."</option>" : '')."
			".(((AUTOGAL_WMARKAUTO)&&($eleInfo['isgallery'])) ? "<option value='autowatermarks'>".AUTOGAL_LANG_MENU_L20."</option>" : '')."
			".(!$eleInfo['isnonimg'] ? "<option value='rotate'>".AUTOGAL_LANG_MENU_L18."</option>" : '')."
			<option value='uploadthumb'>".AUTOGAL_LANG_MENU_L19."</option>
			<option value='setviewsize'>".AUTOGAL_LANG_MENU_L21."</option>
			<option value='clearmeta'>".AUTOGAL_LANG_MENU_L22."</option>
			";
			
			if ($eleInfo['isgallery'])
			{
				$text .= "
				<option value='setdefault'>".AUTOGAL_LANG_MENU_L12."</option>
				<option value='changeperms'>".AUTOGAL_LANG_MENU_L10."</option>
				<option value='creategall'>".AUTOGAL_LANG_MENU_L13."</option>";
			}
		
			$text .= (AUTOGAL_USEXMLMETA ? "<option value='changedesc'>".AUTOGAL_LANG_MENU_L11."</option>" : '')."
			</select>
		</td>
	</tr>
	<tr>
	<td class='forumheader2' colspan='2' style='text-align:center'>
		<input type='submit' class='button' name='ag_admingo' value='".AUTOGAL_LANG_MENU_L14."' /></td>
	</tr>
	".($eleInfo['type'] == "Image" ? "<input type='hidden' name='ag_adminselection' value=\"current\" />" : '')."
	<input type='hidden' name='ag_selele' value=\"".rawurlencode($eleInfo['element'])."\" />
	<input type='hidden' name='start' value=\"".rawurlencode($g_startImage)."\" />
	</table>
	</div>";
	
	$ns -> tablerender(AUTOGAL_LANG_L4, $text); 
}

function AutoGal_ClearPermissions()
{
	global $g_isAdmin;
	
	if (!$g_isAdmin) return;
	
	$gallerys = AutoGal_GalleryList();
	$text = '';
	
	$eleInfo = AutoGal_GetElementInfo('', true);
	$text .= AutoGal_ChangeGalleryUserClass($eleInfo, 'view', AUTOGAL_DEFAULTVIEWUC);
	$text .= AutoGal_ChangeGalleryUserClass($eleInfo, 'upload', AUTOGAL_DEFAULTUPLOADUC);
	$text .= AutoGal_ChangeGalleryUserClass($eleInfo, 'admin', AUTOGAL_DEFAULTADMINUC);
	$text .= AutoGal_ChangeGalleryUserClass($eleInfo, 'mcomment', AUTOGAL_DEFAULTMCOMMENTUC);
	$text .= AutoGal_ChangeGalleryUserClass($eleInfo, 'gcomment', AUTOGAL_DEFAULTGCOMMENTUC);
	
	foreach ($gallerys as $gallery) 
	{
		$eleInfo = AutoGal_GetElementInfo($gallery, true);
		$text .= AutoGal_ChangeGalleryUserClass($eleInfo, 'view', AUTOGAL_DEFAULTVIEWUC);
		$text .= AutoGal_ChangeGalleryUserClass($eleInfo, 'upload', AUTOGAL_DEFAULTUPLOADUC);
		$text .= AutoGal_ChangeGalleryUserClass($eleInfo, 'admin', AUTOGAL_DEFAULTADMINUC);
		$text .= AutoGal_ChangeGalleryUserClass($eleInfo, 'mcomment', AUTOGAL_DEFAULTMCOMMENTUC);
		$text .= AutoGal_ChangeGalleryUserClass($eleInfo, 'gcomment', AUTOGAL_DEFAULTGCOMMENTUC);
	}

	if (!$text) $text = AUTOGAL_LANG_ADMIN_FUNCTIONS_L115;
		
	return $text;
}

function AutoGal_ChangeGalleryUserClass($eleInfo, $type, $class, &$newEleInfo)
{
    $gallery = $eleInfo['element'];
    $type = strtolower($type);
	if ($class == '') $class = 0;

	require_once(e_HANDLER."userclass_class.php");
	
	if ($eleInfo["${type}class"] == $class) return "";
	
	if ($class < 0)
		unset ($eleInfo["${type}class"]);
	else
		$eleInfo["${type}class"] = $class;    

	if (!AutoGal_SetElementInfo($eleInfo, 0, $errMsg))
	{
		return "$errMsg<br />";
	}
		
	$newEleInfo = AutoGal_GetElementInfo($gallery, true);
	
	$ucName = r_userclass_name($class);
	$galleryTitle = AutoGal_GetElementPathTitle($gallery);
	AutoGal_AddAdminLog("${type}UserClassSetting", "Gallery \"$galleryTitle\" Changed to \"$ucName\".");
    
	$className = ($class == -1 ? AUTOGAL_LANG_ADMIN_FUNCTIONS_L108 : AUTOGAL_LANG_ADMIN_FUNCTIONS_L109." \"$ucName\"");
	$msg = AUTOGAL_LANG_ADMIN_FUNCTIONS_L110;
	$msg = str_replace('[GALLERY]', $galleryTitle, $msg);
	$msg = str_replace('[TYPE]', $type, $msg);
	$msg = str_replace('[CLASS]', $className, $msg);
	
	return "$msg<br />";
}

function AutoGal_WriteHtaccess($file, $writeBits='security,leech,watermark')
{
	global $pref;
	
	$htaccessData = '';
	
	if (preg_match("/security/i", $writeBits))
	{
		if ($pref['autogal_apacheindexignore'])
		{
			$htaccessData .= "IndexIgnore *\n\n";
		}
	
		if ($pref['autogal_apachedenyexts'])
		{
			$htaccessData .= 
			"<FilesMatch \"(\.xml$|\.htaccess$|\.log$)\">\n".
			"\torder deny,allow\n".
			"\tDeny from all\n".
			"</FilesMatch>\n\n";
		}
	}
	
	if (preg_match("/leech/i", $writeBits))
	{
		if ($pref['autogal_apacheleechprotect'])
		{
			$serverName = $_SERVER['HTTP_HOST'];
			$serverName = preg_replace("/^http\:\/\//", "", $serverName);
			$serverName = preg_replace("/^www\./", "", $serverName);
			
			$htaccessData .= 
			"RewriteEngine On\n".
			"RewriteCond %{HTTP_REFERER} !^$\n".
			"RewriteCond %{HTTP_REFERER} !^http://(www.)?".preg_quote($serverName).".*$ [NC]\n";
			
			$allowedSites = explode("\n", $pref['autogal_apacheallowedsites']);
			
			foreach ($allowedSites as $site)
			{
				$site = preg_replace("/^http\:\/\//", "", $site);
				$site = preg_replace("/^www\./", "", $site);
				
				if ($site)
				{
					$htaccessData .= "RewriteCond %{HTTP_REFERER} !^http://(www.)?".preg_quote($site).".*$ [NC]\n";
				}
			}
			
			$leechImg = $pref['autogal_apacheleechimage'];
			if ($leechImg)
			{
				$htaccessData .= "RewriteRule \.(".AUTOGAL_SUPPORTEDEXTS.")$ $leechImg [NC,R]\n";
			}
			else
			{
				$htaccessData .= "RewriteRule \.(".AUTOGAL_SUPPORTEDEXTS.")$ - [NC,F]\n\n";
			}
		}
	}
	
	if (preg_match("/watermark/i", $writeBits))
	{
		if ($pref['autogal_wmarkauto'])
		{
			$imgExts = explode('|', AUTOGAL_IMAGEEXTS);
			
			foreach ($imgExts as $ext)
			{
				$htaccessData .= "AddHandler watermarked .$ext\n";
			}
			
			$htaccessData .= "\n";
			$htaccessData .= "<FilesMatch \"^".preg_quote(AUTOGAL_THUMBPREFIX)."\">\n";
			foreach ($imgExts as $ext)
			{
				$htaccessData .= "RemoveHandler .$ext\n";
			}
			$htaccessData .= "</FilesMatch>\n";
			
			$htaccessData .= "\n";
			$htaccessData .= "<FilesMatch \"^".preg_quote(AUTOGAL_DEFAULTIMAGE)."\">\n";
			foreach ($imgExts as $ext)
			{
				$htaccessData .= "RemoveHandler .$ext\n";
			}
			$htaccessData .= "</FilesMatch>\n";
			
			$htaccessData .= "\n";
			$watermarkPath = AutoGal_GetAbsHttpPath(AUTOGAL_WATERMARK);
			$htaccessData .= "Action watermarked $watermarkPath \n";
			
		}
	}
	
	$fh = fopen ($file, 'w+');
	if (!$fh) return 0;
	
	flock($H_HTACCESS, LOCK_EX);
	
	if (strlen($htaccessData) != fwrite($fh, $htaccessData))
	{
		flock($fh, LOCK_UN);
		fclose($fh);
		return 0;
	}
	
	flock($H_HTACCESS, LOCK_UN);
	fclose($fh);
	
	return 1;
}

function AutoGal_WriteCustomBasePaths($httpPath, $absPath, $usingHttps, &$text)
{
	$baseFile = dirname(__FILE__)."/def_basedirs.php";
	
	$usingHttps = strtolower($usingHttps);
	if (!preg_match("/^(always|never|detect)$/", $usingHttps))
	{
		$usingHttps = "detect";
	}
	
	$absPath = preg_replace('/[\\/\\\\]$/', "", $absPath);
	$httpPath = preg_replace('/[\\/\\\\]$/', "", $httpPath);
	if ((!preg_match('/^\//', $httpPath))&&($httpPath)) $httpPath = "/$httpPath";
	
	$text = 
	"<?php\n".
	"define('AUTOGAL_CUSTOMHTTPPATH', \"$httpPath\");\n".
	"define('AUTOGAL_CUSTOMABSPATH', \"$absPath\");\n".
	"define('AUTOGAL_USINGHTTPS', \"$usingHttps\"); /* 'detect', 'never' or 'always' */\n".
	"?>";
	
	$BASEFILE = fopen($baseFile, "w+");
	if (!$BASEFILE) return 0;
	if (!fwrite($BASEFILE, $text)) return 0;
	if (!fclose($BASEFILE)) return 0;
	
	return 1;
}

?>
