<?php
/*********************************************************************************************
 * e107 PLUGIN: Auto Gallery
 * VERSION:     2.xx
 * DESCRIPTION: A media/image gallery, where galleries are based on a directory structure. 
 *              Thumbnails are automatically generated through Imagemagick or GD.
 * WRITTEN BY:  Mr_Visible (www.cerebralsynergy.com)
 * DATE:        12/11/2006
 *
 * Released under the terms and conditions of the
 * GNU General Public License (http://gnu.org).
 ********************************************************************************************/

require_once(dirname(__FILE__)."/language.php");
require_once(dirname(__FILE__)."/def.php");

require_once(e_ADMIN."auth.php");
if(!getperms("P")){ header("location:".e_BASE."index.php"); }
require_once(e_HANDLER."userclass_class.php");

$baseLang = 'English';

if ($_GET['lang'])
{
	$lang = $_GET['lang'];
	
	$baseLangDefs = AutoGal_GetLangDefs(AUTOGAL_LANGDIR."/$baseLang.php");
	$langDefs = AutoGal_GetLangDefs(AUTOGAL_LANGDIR."/$lang.php");
	
	foreach ($baseLangDefs as $defName => $defVal)
	{
		if ($defName == 'AUTOGAL_LANG_AUTHOR') continue;
		if ($defName == 'AUTOGAL_LANG_AUTHORURL') continue;
		if ($defName == 'AUTOGAL_LANG_LASTUPDATE') continue;
		
		if (!isset($langDefs[$defName]))
		{
			$missingDefs[$defName] = $defVal;
		}
	}
	
	ksort($missingDefs);
	
	if (!$missingDefs)
	{
		$text = str_replace('[LANG]', $lang, AUTOGAL_LANG_ADMIN_LANGUAGES_10);
		$text = "<b>$text</b><br />";
	}
	else
	{
		$text = "
		
		<b>".str_replace('[LANG]', $lang, AUTOGAL_LANG_ADMIN_LANGUAGES_11)."</b><br />
		<br />
		<table style='width:97%' class='fborder'>
		<tr style='vertical-align:top'>
			<th style='text-align:center' class='forumheader'><b>".AUTOGAL_LANG_ADMIN_LANGUAGES_12."</b></th>
			<th style='text-align:center' class='forumheader'><b>".str_replace('[BASELANG]', $baseLang, AUTOGAL_LANG_ADMIN_LANGUAGES_13)."</b></th>
		</tr>";
		
		foreach ($missingDefs as $defName => $defVal)
		{
			$text .= "
			<tr>
				<td style='text-align:left' class='forumheader3'>$defName</td>
				<td style='text-align:left' class='forumheader3'>".htmlspecialchars($defVal)."</td>
			</tr>";
		}
		
		$text .= "</table>";
	}
	
	$text .= "<br />
	<a href=\"".AUTOGAL_LANGADMIN."\">".AUTOGAL_LANG_ADMIN_LANGUAGES_14."</a>";
	
	$text = "<div style='text-align:center'>$text</div>";
	
	$ns -> tablerender(AUTOGAL_LANG_ADMIN_LANGUAGES_1, $text);
	require_once(e_ADMIN."footer.php");
	exit;
}

$H_LANGDIR = opendir(AUTOGAL_LANGDIR);

while ($langFile = readdir($H_LANGDIR))
{
	if (!preg_match("/\.php$/i", $langFile)) continue;
	if (preg_match("/\_admin.php$/i", $langFile)) continue;
	
	$path = AUTOGAL_LANGDIR.'/'.$langFile;
	if (preg_match("/^(.+).php$/i", $langFile, $bits))
	{
		$language = $bits[1];
		$langs[$language]['file'] = $langFile;
		
		$langs[$language]['defs'] = AutoGal_GetLangDefs($path);
	}
}

foreach ($langs as $lang => $langInfo)
{
	if ($lang == $baseLang) continue;
	
	foreach ($langs[$baseLang]['defs'] as $defName => $defVal)
	{
		if ($defName == 'AUTOGAL_LANG_AUTHOR') continue;
		if ($defName == 'AUTOGAL_LANG_AUTHORURL') continue;
		if ($defName == 'AUTOGAL_LANG_LASTUPDATE') continue;
		
		if (!isset($langInfo['defs'][$defName]))
		{
			$langs[$lang]['iscomplete'] = 0;
			break;
		}
	}
	
	if (!isset($langs[$lang]['iscomplete']))
	{
		$langs[$lang]['iscomplete'] = 1;
	}
}

ksort($langs);

closedir($H_LANGDIR );

################
# INPUT FIELDS #
################
$text = "<div style='text-align:center'>
".AUTOGAL_LANG_ADMIN_LANGUAGES_15."<br />
<br />
<table style='width:97%' class='fborder'>
<tr style='vertical-align:top'>
    <th style='text-align:center' class='forumheader'><b>".AUTOGAL_LANG_ADMIN_LANGUAGES_2."</b></th>
	<th style='text-align:center' class='forumheader'><b>".AUTOGAL_LANG_ADMIN_LANGUAGES_3."</b></th>
	<th style='text-align:center' class='forumheader'><b>".AUTOGAL_LANG_ADMIN_LANGUAGES_6."</b></th>
	<th style='text-align:center' class='forumheader'><b>".AUTOGAL_LANG_ADMIN_LANGUAGES_4."</b></th>
	<th style='text-align:center' class='forumheader'><b>".AUTOGAL_LANG_ADMIN_LANGUAGES_7."</b></th>
</tr>
";

foreach ($langs as $lang => $langInfo)
{
	$authURL = $langInfo['defs']['AUTOGAL_LANG_AUTHORURL'];
	$lastUpdate = $langInfo['defs']['AUTOGAL_LANG_LASTUPDATE'];
	$author = strip_tags($langInfo['defs']['AUTOGAL_LANG_AUTHOR']);
	
	if (!preg_match("/^\d{1,2}\-\w{3}\-\d{4}$/", $lastUpdate)) $lastUpdate = '';
	
	$isComplete = ($lang == $baseLang ? 1 : $langInfo['iscomplete']);
	
	if ($isComplete)
	{
		$isComplete = "<b><font color='green'>".AUTOGAL_LANG_ADMIN_LANGUAGES_8."</font></b>";
	}
	else
	{
		$isComplete = "<a href=\"".AUTOGAL_LANGADMIN."?lang=".urlencode($lang)."\"><b><font color='red'>".AUTOGAL_LANG_ADMIN_LANGUAGES_9."</font></b></a>";
	}
	
	$lang = "<a href=\"".AUTOGAL_LANGADMIN."?lang=".urlencode($lang)."\">$lang</a>";
	
	$text .= "
	<tr style='vertical-align:top'>
		<td style='text-align:center' class='forumheader3'>".$lang."</td>
		<td style='text-align:center' class='forumheader3'>".($author ? $author : AUTOGAL_LANG_ADMIN_LANGUAGES_5)."</td>
		<td style='text-align:center' class='forumheader3'>".($authURL ? "<a href=\"http://$authURL\">$authURL</a>" : AUTOGAL_LANG_ADMIN_LANGUAGES_5)."</td>
		<td style='text-align:center' class='forumheader3'>".($lastUpdate ? $lastUpdate : AUTOGAL_LANG_ADMIN_LANGUAGES_5)."</td>
		<td style='text-align:center' class='forumheader3'>".$isComplete."</td>
	</tr>";
}

$email = "<a href='mailto:".AUTOGAL_LANGEMAILADDR."'>".AUTOGAL_LANG_ADMIN_LANGUAGES_17."</a>";

$text .= "
</table>
<br />
".str_replace('[EMAIL]', $email, AUTOGAL_LANG_ADMIN_LANGUAGES_16)."<br />
<br />
<a href='http://www.cerebralsynergy.com'><img style='border:0' alt='Cerebral Synergy' src='".e_PLUGIN."autogallery/Images/button.png' /></a><br />
<a href='".AUTOGAL_SUPPORTLINK."'>".AUTOGAL_LANG_ADMIN_MAIN_L46."</a><br />
</div>";

$ns -> tablerender(AUTOGAL_LANG_ADMIN_LANGUAGES_1, $text);

require_once(e_ADMIN."footer.php");

function AutoGal_GetLangDefs($file)
{
	$file = realpath($file);
	if (!$file) return;
	
	$fileLines = file($file);
	
	foreach ($fileLines as $line)
	{
		if (preg_match("/^\s*\#/", $line)) continue;
		if (preg_match("/^\s*\/\//", $line)) continue;
		
		if (preg_match("/define\s*\(\s*[\\\"\'](.+)[\\\"\']\s*\,\s*[\\\"\'](.*)[\\\"\']/", $line, $bits))
		{
			$defs[$bits[1]] = $bits[2];
		}
	}
	
	return $defs;
}

?>

