<?php
/*********************************************************************************************
 * e107 PLUGIN: Auto Gallery
 * VERSION:     2.xx
 * DESCRIPTION: A very simple media gallery, where galleries are based on a directory
 *              structure. For the e107 CMS (http://e107.org).
 * WRITTEN BY:  Mr_Visible (www.cerebralsynergy.com)
 * DATE:        18/11/2006
 *
 * Released under the terms and conditions of the
 * GNU General Public License (http://gnu.org).
 ********************************************************************************************/
 
require_once(dirname(__FILE__)."/def.php");
require_once(dirname(__FILE__)."/admin_functions.php");
require_once(dirname(__FILE__)."/language.php");
 
if (ADMIN)
{
	require_once(e_ADMIN."auth.php");
	if(!getperms("P")){ header("location:".e_BASE."index.php"); }
}
else
{
	define("e_PAGETITLE", AUTOGAL_TITLE.AUTOGAL_LANG_ADMIN_REVIEW_L1);
	require_once(HEADERF);
}

if (!check_class(AUTOGAL_ADMINREVIEWUC))
{
	$ns -> tablerender(AUTOGAL_LANG_ADMIN_REVIEW_L2, "<div style='text-align:center'><b>".AUTOGAL_LANG_ADMIN_REVIEW_L3."</b></div>");
	if (AUTOGAL_SHOW_FOOTER){require_once(FOOTERF);}
	exit;
}

require_once(e_HANDLER."userclass_class.php");

$oneImage = 0;
$text = "";
$dh = opendir(AUTOGAL_UPLOADDIRABS);
$fileID = 0;

while ($file = readdir($dh))
{
    if (AutoGal_IsSupportedFormat($file))
    { 
		if (preg_match("/^".preg_quote(AUTOGAL_THUMBPREFIX)."/", $file)) continue;
		
        $fileLoc = AUTOGAL_UPLOADDIRABS."/$file";
		$fileUrl = AUTOGAL_UPLOADDIR."/$file";
		$fileAbsPath = realpath($fileLoc);
		$fileXML = $fileLoc.".xml";
        $fileOp = AutoGal_HTMLFieldPost("op_$fileID");
        $fileTitle = AutoGal_HTMLFieldPost("title_$fileID");
		$fileDesc = stripslashes(AutoGal_HTMLFieldPost("description_$fileID"));
        $oneImage = 1;
		
		# GET THE THUMBNAIL IF ONE UPLOADED
		$thumbPath = AutoGal_GetFileThumb($fileAbsPath);
		$thumbURL = '';
		if ($thumbPath)
		{
			$thumbURL = AUTOGAL_UPLOADDIR."/".basename($thumbPath);
		}
		else if ((AUTOGAL_AUTOTHUMB)&&(AutoGal_IsImage($file)))
		{
			$thumbPath = AutoGal_GetFileThumb($fileAbsPath, true);
			$error = AutoGal_ResizeImage($fileAbsPath, $thumbPath, AUTOGAL_THUMBWIDTH, AUTOGAL_THUMBHEIGHT);
			
			if ($error)
			{
				print "<font color='red'><b>".AUTOGAL_LANG_UPLOAD_L25."</b></font> $error<br />";
			}
			else
			{
				$thumbPath = AutoGal_GetFileThumb($fileAbsPath);
				if ($thumbPath) $thumbURL = AUTOGAL_UPLOADDIR."/".basename($thumbPath);
			}
		}
		
        if (($_POST['moderateimages'])&&($fileOp != '|leave|'))
        {
            if ($fileOp == '|delete|')
            {
				$text .= "<tr><td colspan='3' class='forumheader3'>";
				
                if (unlink ($fileLoc))
                {
					$text .= str_replace('[FILE]', $file, AUTOGAL_LANG_ADMIN_REVIEW_L4)."\n";
					AutoGal_AddAdminLog("ReviewDelete", "Submitted File \"$file\".");
                }
                else
                {
                   $text .= str_replace('[FILE]', $file, AUTOGAL_LANG_ADMIN_REVIEW_L5)."\n";
                }
				
				if (file_exists($fileXML))
				{
					if (unlink($fileXML))
					{
						$text .= "<br />".str_replace('[XMLFILE]', $fileXML, AUTOGAL_LANG_ADMIN_REVIEW_L6)."\n";
					}
					else
					{
						$text .= "<br />".str_replace('[XMLFILE]', $fileXML, AUTOGAL_LANG_ADMIN_REVIEW_L7)."\n";
					}
				}
				
				$text .= "</td></tr>";
            }
            else
            {
				$text .= "<tr><td colspan='3' class='forumheader3'>";
			
                $fileInfo = pathinfo($file);
                
                $newFilename = str_replace(' ', '_', $fileTitle.'.'.$fileInfo['extension']); 
				$newFilename = preg_replace("/[\/\\\*\<\>\|\:\"\?]/", "", $newFilename); 
                $newPath = AutoGal_GetAbsGalPath('').($fileOp ? '/'.rawurldecode($fileOp) : '')."/$newFilename";

				$galTitle = AutoGal_GetElementPathTitle(rawurldecode($fileOp), 0, '-&gt;');
				$galTitle = ($fileOp ? $galTitle : AutoGal_GetTitle(AUTOGAL_ROOTNAME, 1, 'title'));
				#print "rename($fileAbsPath, $newPath)<br />";
                
				if (file_exists($newPath))
				{
					$text .= "<br />".str_replace('[PATH]', $newPath, AUTOGAL_LANG_ADMIN_REVIEW_L31);
				}
				else if (rename($fileAbsPath, $newPath))
                {
					$text .= str_replace('[FILE]', $file, AUTOGAL_LANG_ADMIN_REVIEW_L8)."[<a href='".AUTOGAL_AUTOGALLERY."?show=".rawurlencode($fileOp)."'>$galTitle</a>]";
					
					if (!chmod ($newPath, octdec(AUTOGAL_PERMSGALDIR)))
					{
						$text .= "<br />".str_replace('[PATH]', $newPath, AUTOGAL_LANG_ADMIN_REVIEW_L9);
					}
					
					AutoGal_AddAdminLog("ReviewAccept", "Submitted File \"$file\" to gallery \"$galTitle\".");
					
					if ((!file_exists($fileXML))&&($fileDesc))
					{
						require_once(dirname(__FILE__)."/autogalmeta_class.php");
						$xmlMeta = new AutoGal_CMeta;
						
						$xmlMeta->m_metaData['description'] = $fileDesc;
						if ($xmlMeta->SaveFile("$newPath.xml", AUTOGAL_PERMSGALXML))
						{
							$text .= "<br />".AUTOGAL_LANG_ADMIN_REVIEW_L11;
						}
						else
						{
							$text .= "<br />".AUTOGAL_LANG_ADMIN_REVIEW_L12.$xmlMeta->GetLastError()."!";
						}						
					}
					else if ((file_exists($fileXML))||($fileDesc))
					{
						if (AUTOGAL_USEXMLMETA)
						{
							if (rename ($fileXML, "$newPath.xml"))
							{
								$text .= "<br />".AUTOGAL_LANG_ADMIN_REVIEW_L10;
	
								require_once(dirname(__FILE__)."/autogalmeta_class.php");
								$xmlMeta = new AutoGal_CMeta;
								
								if ($xmlMeta->LoadFile("$newPath.xml"))
								{
									if ($xmlMeta->m_metaData['description'] != $fileDesc)
									{
										$xmlMeta->m_metaData['description'] = $fileDesc;
										if ($xmlMeta->SaveFile("$newPath.xml", AUTOGAL_PERMSGALXML))
										{
											$text .= "<br />".AUTOGAL_LANG_ADMIN_REVIEW_L11;
										}
										else
										{
											$text .= "<br />".AUTOGAL_LANG_ADMIN_REVIEW_L12.$xmlMeta->GetLastError()."!";
										}
									}
								}
								else
								{
									$text .= "<br />".AUTOGAL_LANG_ADMIN_REVIEW_L13.$xmlMeta->GetLastError()."!";
								}
							}
							else
							{
								$text .= "<br />".AUTOGAL_LANG_ADMIN_REVIEW_L14."$fileXML!";
							}
						}
						else
						{
							if (unlink($fileXML))
							{
								$text .= "<br />".AUTOGAL_LANG_ADMIN_REVIEW_L15;
							}
							else
							{
								$text .= "<br />".AUTOGAL_LANG_ADMIN_REVIEW_L16."$fileXML!";
							}
						}
					}
					
					if ($thumbPath)
					{
						if (AutoGal_IsImage($newPath))
						{
							$newThumbPath = AutoGal_GetFileThumb($newPath, true);
						}
						else
						{
							$thumbPathInfo = pathinfo($thumbPath);
							$filePathInfo = pathinfo($newPath);
							
							$newThumbPath = $filePathInfo['dirname'].'/'.AUTOGAL_THUMBPREFIX.$filePathInfo['basename'].'.'.$thumbPathInfo['extension'];
						}

						if (rename($thumbPath, $newThumbPath))
						{
							$text .= "<br />".AUTOGAL_LANG_ADMIN_REVIEW_L30;
						}
						else
						{
							$text .= "<br />".str_replace('[FILE]', basename($thumbPath), str_replace('[PATH]', dirname($newThumbPath), AUTOGAL_LANG_ADMIN_REVIEW_L17))."\n";
						}
					}
                }                                                                                                                    
                else
                {
                    $text .= str_replace('[FILE]', $file, str_replace('[PATH]', $newPath, AUTOGAL_LANG_ADMIN_REVIEW_L17))."\n";
                }
				
				$text .= "</td></tr>\n";
            }
        }
        else
        {
			$fileTitle = AutoGal_GetTitle($fileLoc, 0, 'full');
			
			$xmlOK = false;
			if (AUTOGAL_USEXMLMETA)	
			{
				$eleXMLInfo = AutoGal_GetElementXMLInfo($fileLoc);
				$xmlOK = $eleXMLInfo['xmlfileexists'];
			}
			
			$suggestedGal = '<NULL>';
			if (($xmlOK)&&(array_key_exists('suggestedgallery', $eleXMLInfo)))
			{
				$suggestedGal = rawurldecode($eleXMLInfo['suggestedgallery']);
			}
			
			# GALLERY SELECTION BOX
			$gallerys = AutoGal_GalleryList();
			$gallerys[] = '';
			$galSelect = '';
			$galIndex = 2;
			foreach ($gallerys as $gallery)
			{
				$galleryTitle = AutoGal_GetElementPathTitle($gallery, 0, " -> ");
				$isSuggGal = 0;
				if (($suggestedGal != '<NULL>')&&($gallery == $suggestedGal))
				{
					$isSuggGal = 1;
					$suggGalIndex = $galIndex;
				}
				
				$galSelect .= "<option".($isSuggGal ? " style='font-weight:bold'" : '')." value=\"".rawurlencode($gallery)."\">$galleryTitle".($isSuggGal ? AUTOGAL_LANG_ADMIN_REVIEW_L32 : '')."</option>\n";
				$galIndex ++;
			}
			
			$viewLink = '';
			if ($thumbURL) $viewLink = "<a href=\"$fileUrl\"><img src=\"$thumbURL\" style='border:none'></a><br />";
			$viewLink .= "[<a href=\"$fileUrl\">".AUTOGAL_LANG_ADMIN_REVIEW_L18."</a>]";

            $text .= "
            <tr>
                <td class='forumheader3' style='text-align:center'>$viewLink</td>
                <td class='forumheader3'>
					<input size='50' class='tbox' name=\"".AutoGal_HTMLField("title_$fileID")."\" value=\"$fileTitle\">".
					(AUTOGAL_USEXMLMETA ? "<br /><br />".
					($xmlOK ? "<b>".AUTOGAL_LANG_ADMIN_REVIEW_L19."</b> ".$eleXMLInfo['submituserlink']."<br />" : '').
					($xmlOK ? "<b>".AUTOGAL_LANG_ADMIN_REVIEW_L20."</b> ".strftime("%H:%M:%S %d-%b-%Y", $eleXMLInfo['submitdate'])."<br />" : '').
					"<b>".AUTOGAL_LANG_ADMIN_REVIEW_L21."</b><br />
					<textarea class=\"tbox\" name=\"".AutoGal_HTMLField("description_$fileID")."\" cols=\"45\" rows=\"5\">".
					$eleXMLInfo['description'].
					"</textarea>" : '')."
				</td>
                <td class='forumheader3' style='text-align:center'>
                    <select name=\"".AutoGal_HTMLField("op_$fileID")."\" class='tbox' id=\"op_$fileID\">
                    <option value='|leave|' selected>&lt;".AUTOGAL_LANG_ADMIN_REVIEW_L22."&gt;</option>
                    <option value='|delete|'>&lt;".AUTOGAL_LANG_ADMIN_REVIEW_L23."&gt;</option>
                    $galSelect
                    </select>
					".($suggestedGal != '<NULL>' ? "<br /><br /><input value='".AUTOGAL_LANG_ADMIN_REVIEW_L33."' type='button' class='button' onclick=\"javascript:document.getElementById('op_$fileID').selectedIndex=$suggGalIndex;\">" : '')."
                </td> 
            </tr>";
        }
		
		$fileID ++;
    }
}
closedir($dh);

$botLinks = AutoGal_GetBotLinks('', false);

if ($oneImage)
{
    $text = "
    <div style='text-align:center'>
    <form method='post' action='".e_SELF."'>
    <br />
    <table style='width:85%' class='fborder' colspan='3'>
    <tr>
        <th class='forumheader'>".AUTOGAL_LANG_ADMIN_REVIEW_L24."</th>
        <th class='forumheader'>".AUTOGAL_LANG_ADMIN_REVIEW_L25."</th>
        <th class='forumheader'>".AUTOGAL_LANG_ADMIN_REVIEW_L26."</th>
    </tr>
    $text
    <tr style='vertical-align:top'>
        <td colspan='3' style='text-align:center' class='forumheader'>
            <input class='button' type='submit' name='moderateimages' value='".AUTOGAL_LANG_ADMIN_REVIEW_L27."'>
        </td>
    </tr>
    </table>"
    .(count($botLinks) > 0 ? "<br />".implode(' ', $botLinks) : '').
    "</form>
    </div>";
}
else
{
    $text = "<div style='text-align:center'><br /><b>".AUTOGAL_LANG_ADMIN_REVIEW_L28."</b><br />"
    .(count($botLinks) > 0 ? "<br />".implode(' ', $botLinks) : '').
    "<br /></div>";
}

$ns -> tablerender(AUTOGAL_LANG_ADMIN_REVIEW_L29, $text);

if (ADMIN)
{
	require_once(e_ADMIN."footer.php");
}
else
{
	if (AUTOGAL_SHOW_FOOTER){require_once(FOOTERF);}
}

?>
