<?php
/*********************************************************************************************
 * e107 PLUGIN: Auto Gallery
 * VERSION:     2.xx
 * DESCRIPTION: A very simple media gallery, where galleries are based on a directory
 *              structure. For the e107 CMS (http://e107.org)
 * WRITTEN BY:  Mr_Visible (www.cerebralsynergy.com)
 *              Kevin Finnin (finnin.net) - e107 search integration
 * DATE:        13/11/2006
 *
 * Released under the terms and conditions of the
 * GNU General Public License (http://gnu.org).
 ********************************************************************************************/

require_once(dirname(__FILE__)."/def.php");
require_once(dirname(__FILE__)."/language.php");

if (!AUTOGAL_ENABLESEARCHE107)
{
	$text = AUTOGAL_LANG_SEARCH_L32;
	return $text;
}

$smallformTable = AUTOGAL_SEARCHSMALLFORM; 

$searchMatch    = $query;
$searchForGal   = true;
$searchForImg   = true;
$searchForFla   = true;
$searchForMov   = true;
$searchForAud   = true;

$searchGallery  = ($_GET['gallery'] ? rawurldecode($_GET['gallery']) : '');
$searchGallery  = ($_POST['autogal_searchGallery'] ? rawurldecode($_POST['autogal_searchGallery']) : $searchGallery);

$searchFieldNam = true;
$searchFieldExt = true;
$searchFieldSub = AUTOGAL_XMLSEARCH;
$searchFieldDes = AUTOGAL_XMLSEARCH;
$searchGo       = $_POST['autogal_searchGo'];

$resultsSortBy = 'title';

$start = ($_GET['start'] ? $_GET['start'] : 0);

define("e_PAGETITLE", AUTOGAL_TITLE. " / " . AUTOGAL_LANG_SEARCH_L1);
require_once(HEADERF);

$text = "";

if (strlen(str_replace("*", "", $searchMatch)) < AUTOGAL_MINSEARCHSTRLEN)
{
	$text .= "<br /><br /><div style='text-align:center'><b>".str_replace("[MINSEARCHLEN]", AUTOGAL_MINSEARCHSTRLEN, AUTOGAL_LANG_SEARCH_L18)."</b></div>";
}
elseif ((!$searchForGal)&&(!$searchForImg)&&(!$searchForFla)&&(!$searchForMov))
{
	$text .= "<br /><br /><div style='text-align:center'><b>".AUTOGAL_LANG_SEARCH_L19."</b></div>";
}
elseif ((!$searchFieldNam)&&(!$searchFieldExt)&&(AUTOGAL_USEXMLMETA && AUTOGAL_XMLSEARCH && (!$searchFieldDes)&&(!$searchFieldSub)))
{
	$text .= "<br /><br /><div style='text-align:center'><b>".AUTOGAL_LANG_SEARCH_L20."</b></div>";
}
else
{
	$numResults = 0;
	$numTests = 0;
	$isSearchMeta = (((AUTOGAL_USEXMLMETA)&&(AUTOGAL_XMLSEARCH))&&(($searchFieldDes)||($searchFieldSub)));
	$searchStr = preg_quote($searchMatch);
	$searchStr = str_replace("\*", ".*", $searchStr);
	$searchResults = array();
	
	$eles = AutoGal_GetGalleryElements($searchGallery, true, 'name');
	$eles = array_merge($eles['galleries'], $eles['files']);
	
	foreach ($eles as $eleInfo)
	{
		$element = $eleInfo['element'];
		
		if ($isSearchMeta)
		{
			$eleInfo = AutoGal_GetElementInfo($element, true);
		}
		
		if ($eleInfo['isgallery'])
		{
			if (!$searchForGal) continue;
		}
		else
		{
			if (!$eleInfo['isnonimg'] && !$searchForImg) continue;
			if ($eleInfo['isflash'] && !$searchForFla) continue;
			if ($eleInfo['ismovie'] && !$searchForMov) continue;
			if ($eleInfo['isaudio'] && !$searchForAud) continue;
		}

		$criteraOK = false;
		if ((!$criteraOK)&&($searchFieldNam))
		{
			if (preg_match("/($searchStr)/mi", $eleInfo['title'], $match)) {$eleInfo["__searchMatch__"] = $match[1]; $criteraOK = true;}
		}
		if ((!$criteraOK)&&($searchFieldExt))
		{
			if (preg_match("/($searchStr)/mi", $eleInfo['extension'], $match)) {$eleInfo["__searchMatch__"] = $match[1]; $criteraOK = true;}
		}
		if ((!$criteraOK)&&($searchFieldSub))
		{
			if (preg_match("/($searchStr)/mi", $eleInfo['submitbyusername'], $match)) {$eleInfo["__searchMatch__"] = $match[1]; $criteraOK = true;}
		}
		if ((!$criteraOK)&&($searchFieldDes))
		{
			$desc = $eleInfo['description'];
			$desc = preg_replace("/\[[\/\w\=\s]+\]/", '', $desc);
			$desc = str_replace("\n", ' ', $desc);
			if (preg_match("/($searchStr)/mi", $desc, $match)) {$eleInfo["__searchMatch__"] = $match[1]; $criteraOK = true;}
		}
		
		if ($criteraOK)
		{
			$searchResults[] = $eleInfo;
			$numResults ++;
		}
		
		if ($numResults > AUTOGAL_SEARCHMAXRESULTS) break;
	}
	
	if ($numResults <= 0)
	{
		$text .= AUTOGAL_LANG_SEARCH_L21;
	}
	else
	{
		$text .= "
		<br />
		<table class='border' width='97%'>
		<tr>
			<td class='forumheader' style='text-align:center'><b>".AUTOGAL_LANG_SEARCH_L23."</b></td>
			<td class='forumheader' style='text-align:center'><b>".AUTOGAL_LANG_SEARCH_L24."</b></td>
			<td class='forumheader' style='text-align:center'><b>".AUTOGAL_LANG_SEARCH_L25."</b></td>";

		if (!$smallformTable){
			$text .=
			($searchFieldExt ? "<td class='forumheader' style='text-align:center'><b>".AUTOGAL_LANG_SEARCH_L26."</b></td>" : '').
			($searchFieldSub ? "<td class='forumheader' style='text-align:center'><b>".AUTOGAL_LANG_SEARCH_L27."</b></td>" : '').
			($searchFieldDes ? "<td class='forumheader' style='text-align:center'><b>".AUTOGAL_LANG_SEARCH_L28."</b></td>" : '');
		}
		$text .= "</tr>\n";
		
		foreach ($searchResults as $eleInfo)
		{
			$name = $eleInfo['title'];
			$name = preg_replace("/".preg_quote($eleInfo['__searchMatch__'])."/im", "<font color='red'><b>".$eleInfo['__searchMatch__']."</b></font>", $name);
			$name = $eleInfo['ahref'].">$name</a>";
			
			$thumb = "";
			if ($eleInfo['type'] == 'Gallery')
			{
				if ($eleInfo['defimg'])
				{
					$thumb = "<a href=\"".$eleInfo['link']."\">".$eleInfo['defimghtml']."</a>";
				}
			}
			else
			{
				$thumb = $eleInfo['ahref'].">".$eleInfo['imgthumbhtml']."</a>";
			}
			
			if ($eleInfo['description']) //(Long)
			{
				$desc = $eleInfo['description'];
				$desc = preg_replace("/\[[\/\w\=\s]+\]/", '', $desc);
				$desc = str_replace("\n", ' ', $desc);
				$desc = preg_replace("/".preg_quote($eleInfo['__searchMatch__'])."/im", "<font color='red'><b>".$eleInfo['__searchMatch__']."</b></font>", $desc);
			}
			else
			{
				$desc = '-';
			}
			if(!shortformTable){
				$ext = $eleInfo['extension'];
				print $ext;
				$ext = preg_replace("/".preg_quote($eleInfo['__searchMatch__'])."/im", "<font color='red'><b>".$eleInfo['__searchMatch__']."</b></font>", $ext);
			
				$subUsername = $eleInfo['submitbyusername'];
				$subUsername = preg_replace("/".preg_quote($eleInfo['__searchMatch__'])."/im", "<font color='red'><b>".$eleInfo['__searchMatch__']."</b></font>", $subUsername);
			
				if ($eleInfo['submitbyuserid'] > 0)
				{
					$eleInfo['submituserlink'] = "<a href=\"".e_BASE."user.php?id.".$eleInfo['submitbyuserid']."\">$subUsername</a>";
				}
				else
				{
					$eleInfo['submituserlink'] = $subUsername;
				}
			}
							
			$long = parsesearch($desc, $query);;

			$text .= "
			<tr>
				<td class='forumheader3' style='text-align:center'>".($thumb ? "$thumb<br />" : '')."$name</td>
				<td class='forumheader3' style='text-align:center'><a href=\"".AUTOGAL_AUTOGALLERY.($eleInfo['gallery'] == '' ? '' : "?show=".rawurlencode($eleInfo['gallery']))."\">".($eleInfo['gallery'] == '' ? AUTOGAL_ROOTNAME : $eleInfo['title'])."</a></td>
				<td class='forumheader3' style='text-align:center'>".$eleInfo['filetypetitle']."</td>";

			if (!$smallformTable){
			$text .=
				($searchFieldExt ? "<td class='forumheader3' style='text-align:center'>$ext</td>" : '').
				($searchFieldSub ? "<td class='forumheader3' style='text-align:center'>".$eleInfo['submituserlink']."</td>" : '').
				($searchFieldDes ? "<td class='forumheader3' style='text-align:center'>$desc</td>" : '');
				}else{
			$text .="</tr><tr><td colspan='3' class='forumheader3' style='text-align:center'>".$long."</td>";
				}
			
			$text .="</tr>\n";
		}
		
		$text .= "</table>\n".($numResults >= AUTOGAL_SEARCHMAXRESULTS ? "<br />".str_replace("[MAXRESULTS]", AUTOGAL_SEARCHMAXRESULTS, AUTOGAL_LANG_SEARCH_L29) : '');
	}
}

return $text;	

/*****************************************************************************************************
 * 
 ****************************************************************************************************/
function AutoGal_CmpSearchResults($a, $b)
{
	global $sortBy;

	$cmpA = $a[$resultsSortBy];
	$cmpB = $b[$resultsSortBy];
	
	$cmpA = strtolower($cmpA);
	$cmpB = strtolower($cmpB );
      
	if ($cmpA == $cmpB) return 0;
	return ($cmpA < $cmpB) ? -1 : 1;
}

?>