<?php
/*********************************************************************************************
 * e107 PLUGIN: Auto Gallery
 * VERSION:     2.xx
 * DESCRIPTION: A media/image gallery, where galleries are based on a directory structure. 
 *              Thumbnails are automatically generated through Imagemagick or GD.
 * WRITTEN BY:  Mr_Visible (www.cerebralsynergy.com)
 * DATE:        11/04/2007
 *
 * Released under the terms and conditions of the
 * GNU General Public License (http://gnu.org).
 ********************************************************************************************/

$startAG = microtime(true);

require_once(dirname(__FILE__)."/def.php");
require_once(dirname(__FILE__)."/language.php");
if (file_exists(AUTOGAL_LANGDIR."/".e_LANGUAGE."_Admin.php"))
{
	require_once(AUTOGAL_LANGDIR."/".e_LANGUAGE."_Admin.php");
}
else
{
	require_once(AUTOGAL_LANGDIR."/English_Admin.php");
}
require_once(e_HANDLER."userclass_class.php");
require_once(AUTOGAL_ADMINFUNCTIONS);

define("e_PAGETITLE", AUTOGAL_TITLE. " / " . AUTOGAL_LANG_STAT_L12);
require_once(HEADERF);

$g_startImage = (preg_match("/^\d+$/", $_GET['start']) ? $_GET['start'] : (preg_match("/^\d+$/", $_POST['start']) ? $_POST['start'] : 0));
$g_showFullImage = (preg_match("/^\d+$/", $_GET['full']) ? rawurldecode($_GET['full']) : 0);
$g_isNewWindow = (preg_match("/^\d+$/", $_GET['newwindow']) ? $_GET['newwindow'] : 0);
$g_selElement = rawurldecode($_POST['ag_selele']);
$g_absPath = AutoGal_GetAbsGalPath($g_selElement);
$g_galAbsPath = AutoGal_GetAbsGalPath('');
$g_isAdmin = (check_class($g_selEleInfo['adminclass']) || ADMIN ? 1 : 0);
$g_isAdminMode = ($g_isAdmin ? AutoGal_IsAdminMode() : false);

if (preg_match("/^".preg_quote($g_galAbsPath, '/')."/", $g_absPath))
{
	$g_selEleInfo = AutoGal_GetElementInfo($g_selElement, true);
}
else
{
	$g_selEleInfo = NULL;
}

print "\n<!-- AUTOGALLERY START -->\n\n";
if (!$g_selEleInfo)
{
	$text .= "<div style='text-align:center'><br />".AUTOGAL_LANG_L2."<br /><br /><b>".htmlspecialchars($g_selElement)."</b><br /><br /><a href=\"".AUTOGAL_AUTOGALLERY."\">".AUTOGAL_LANG_L3."</a><br /><br /></div>";
	$ns -> tablerender(AUTOGAL_TITLE, $text);
	if (AUTOGAL_SHOW_FOOTER){require_once(FOOTERF);}
}
else
{
	$text = AutoGal_DoAdminAction($g_selEleInfo);
	$ns -> tablerender(AUTOGAL_TITLE, $text);
}

print "\n<!-- AUTOGALLERY END -->\n\n";
if (AUTOGAL_SHOW_FOOTER){require_once(FOOTERF);}

function AutoGal_DoAdminAction($eleInfo)
{
	global $g_startImage;
	global $g_isAdminMode;
	global $g_isAdmin;
	
	if (!$g_isAdmin) return "Not an administrator";
	if (!$g_isAdminMode) return "Not in admin mode";
	
	$action = $_POST['ag_adminaction'];
	$selection = $_POST['ag_adminselection'];
	
	if ($selection == 'current')
	{
		$eles[] = $eleInfo;
	}
	else if ($selection == 'all')
	{
		$eles = AutoGal_GetGalleryElements($eleInfo['element']);
		$eles = array_merge($eles['galleries'], $eles['files']);
	}
	else if ($selection == 'files')
	{
		$eles = AutoGal_GetGalleryElements($eleInfo['element']);
		$eles = $eles['files'];
	}
	else if ($selection == 'galleries')
	{
		$eles = AutoGal_GetGalleryElements($eleInfo['element']);
		$eles = $eles['galleries'];
	}
	else
	{
		$allEles = AutoGal_GetGalleryElements($eleInfo['element']);
		$allEles = array_merge($allEles['galleries'], $allEles['files']);
		
		foreach ($allEles as $ele)
		{
			$eleVarName = "ag_ele_".preg_replace("/[\.\s]/", '_', urlencode($ele['element']));
			
			if (($selection == 'checked')&&($_POST[$eleVarName]))
			{
				$eles[] = $ele;
			}
			else if (($selection == 'unchecked')&&(!$_POST[$eleVarName]))
			{
				$eles[] = $ele;
			}
		}
	}
	
	if ($action != 'creategall')
	{
		if (!$eles)
		{
			$errorMsg = AUTOGAL_LANG_ADMIN_EDIT_1;
		}
		else
		{
			foreach ($eles as $ele)
			{
				if ($ele['isroot'])
				{
					$errorMsg = AUTOGAL_LANG_ADMIN_EDIT_2;
					continue;
				}
			}
		}
		
		if ($errorMsg)
		{
			$text .= "<div style='text-align:center'>
			<br />
			<b>$errorMsg</b><br />
			<br />
			[<a href=\"".$eleInfo['backlink']."\">".AUTOGAL_LANG_ADMIN_EDIT_3.$eleInfo['filetypetitle']." '".($eleInfo['title'] ? $eleInfo['title'] : AUTOGAL_ROOTNAME)."'</a>]<br />
			<br />	
			</div>";
			return $text;
		}
	}
	
	$text = "<form method='post'".($action == 'uploadthumb' ? " enctype='multipart/form-data'" : '').">
	<input type='hidden' name='ag_adminaction' value='$action'>
	<input type='hidden' name='ag_selele' value=\"".rawurlencode($eleInfo['element'])."\">
	<input type='hidden' name='ag_adminselection' value='$selection'>
	<input type='hidden' name='start' value='$g_startImage'>";
	
	foreach ($_POST as $postVar => $postVal)
	{
		if (preg_match('/^ag\_ele\_/', $postVar))
		{
			$text .= "<input type='hidden' name='$postVar' value=\"$postVal\">\n";
		}
	}
		
	if ($action == 'rename')
	{
		$text .= AutoGal_PageRenameElements($eleInfo, $eles);
	}
	else if ($action == 'delete')
	{
		$text .= AutoGal_PageDeleteElements($eleInfo, $eles);
	}
	else if ($action == 'move')
	{
		$text .= AutoGal_PageMoveElements($eleInfo, $eles);
	}
	else if ($action == 'setdefault')
	{
		$text .= AutoGal_PageSetDefaultImage($eleInfo, $eles);
	}
	else if ($action == 'creategall')
	{
		$text .= AutoGal_PageCreateGallery($eleInfo, $eles);
	}
	else if ($action == 'changeperms')
	{
		$text .= AutoGal_PageChangeUserClasses($eleInfo, $eles);
	}
	else if ($action == 'changedesc')
	{
		$text .= AutoGal_PageChangeDescription($eleInfo, $eles);
	}
	else if ($action == 'watermark')
	{
		$text .= AutoGal_PageWatermark($eleInfo, $eles);
	}
	else if ($action == 'rotate')
	{
		$text .= AutoGal_PageRotate($eleInfo, $eles);
	}
	else if ($action == 'uploadthumb')
	{
		$text .= AutoGal_PageUploadThumb($eleInfo, $eles);
	}
	else if ($action == 'autowatermarks')
	{
		$text .= AutoGal_AutoWatermarking($eleInfo, $eles);
	}
	else if ($action == 'setviewsize')
	{
		$text .= AutoGal_PageSetViewSize($eleInfo, $eles);
	}
	else if ($action == 'clearmeta')
	{
		$text .= AutoGal_PageClearMeta($eleInfo, $eles);
	}
			
	$text .= "</form>";
	
	return $text;
}

function AutoGal_PageRenameElements($selEleInfo, $eles)
{
	global $ns;
	
	if ($_POST['ag_doit'])
	{
		// Submit button pressed
		foreach ($eles as $eleI => $ele)
		{
			$eleVarName = preg_replace("/[\.\s]/", '_', urlencode($ele['element']));
			
			$newTitle = $_POST["ag_title_".$eleVarName];
			$newOrderNum = $_POST["ag_num_".$eleVarName];
			
			if (($ele['fulltitle'] != $newTitle)||($ele['num'] != $newOrderNum))
			{
				$atLeast1 = 1;
				$text .= AutoGal_RenameElement($ele, $newTitle, $newOrderNum, $newEle);
			}
		}
		
		if (!$atLeast1)
		{
			$text .= "<div style='text-align:center'><b>".AUTOGAL_LANG_ADMIN_EDIT_4."</b><br />";
		}
		
		if (($selEleInfo['element'] == $eles[0]['element'])&&(count($eles) == 1))
		{
			$backEle = $newEle;
		}
		else
		{
			$backEle = $selEleInfo;
		}
		
		$text .= "
		[<a href=\"".$backEle['backlink']."\">".AUTOGAL_LANG_ADMIN_EDIT_3.$backEle['filetypetitle']." '".($backEle['title'] ? $backEle['title'] : AUTOGAL_ROOTNAME)."'</a>]<br />
		<br />";		
		return $text;
	}
	
	$text .= "
	<table class='border' style='width:97%'>
	<tr>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_5."</th>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_6."</th>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_7."</th>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_8."</th>
	</tr>";
	
	foreach ($eles as $ele)
	{
		$thumbImg = ($ele['type'] == 'Gallery' ? $ele['defimghtml'] : $ele['imgthumbhtml']."<br />");
	
		$text .= "
		<tr>
			<td class='forumheader3' style='text-align:center'>".
				$ele['filetypetitle']."
			</td>
			<td class='forumheader3' style='text-align:center'>".
				($thumbImg ? $ele['ahref'].">".$thumbImg : '').
				$ele['ahref'].">".$ele['title']."</a>
			</td>
			<td class='forumheader3' style='text-align:center'>
				<input type='text' name=\"ag_num_".urlencode($ele['element'])."\" size='3' class='tbox' value=\"".($ele['num'] >= 0 ? $ele['num'] : '')."\">
			</td>
			<td class='forumheader3' style='text-align:center'>
				<input type='text' name=\"ag_title_".urlencode($ele['element'])."\" size='40' class='tbox' value=\"".$ele['fulltitle']."\">
			</td>
		</tr>";
	}
	
	$text .= "
	<tr>
		<td colspan='4' class='forumheader' style='text-align:center'>
			<input type='submit' class='button' name='ag_doit' value='".AUTOGAL_LANG_ADMIN_EDIT_9."'>
		</td>
	</tr>
	</table>";
	
	return $text;
}

function AutoGal_PageDeleteElements($selEleInfo, $eles)
{
	if ($_POST['ag_doit'])
	{
		foreach ($eles as $ele)
		{
			$text .= AutoGal_DeleteElement($ele);
		}
		
		if (($selEleInfo['element'] == $eles[0]['element'])&&(count($eles) == 1))
		{
			$backEle = AutoGal_GetElementInfo($selEleInfo['gallery']);
		}
		else
		{
			$backEle = $selEleInfo;
		}
		
		$text .= "
		<br />
		[<a href=\"".$backEle['backlink']."\">".AUTOGAL_LANG_ADMIN_EDIT_3.$backEle['filetypetitle']." '".($backEle['title'] ? $backEle['title'] : AUTOGAL_ROOTNAME)."'</a>]<br />";		
		
		return $text;
	}
	
	$text = "
	<br />
	<div style='text-align:center'>
	<b>".AUTOGAL_LANG_ADMIN_EDIT_41."</b><br />
	<br />
	<table class='border' style='width:97%'>
	<tr>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_5."</th>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_6."</th>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_39."</th>
	</tr>";
	
	foreach ($eles as $ele)
	{
		$thumbImg = ($ele['type'] == 'Gallery' ? $ele['defimghtml'] : $ele['imgthumbhtml']."<br />");
	
		$text .= "
		<tr>
			<td class='forumheader3' style='text-align:center'>".
				$ele['filetypetitle']."
			</td>
			<td class='forumheader3' style='text-align:center'>".
				($thumbImg ? $ele['ahref'].">".$thumbImg : '').
				$ele['ahref'].">".$ele['title']."</a>
			</td>
			<td class='forumheader3' style='text-align:center'>
				".$ele['fulltitle']."
			</td>
		</tr>";
	}
	
	$text .= "</table>
	<br />
	<input type='submit' class='button' name='ag_doit' value='".AUTOGAL_LANG_ADMIN_EDIT_40."'>
	<input type='button' class='button' name='ag_doit' value='".AUTOGAL_LANG_ADMIN_EDIT_30."' onclick='javascript:history.go(-1)'>
	</div>";
	
	return $text;
}

/*****************************************************************************************************
 * DELETES A DIRECTORY INCLUDING ALL SUB DIRECTORIES AND FILES - RIPPED FROM PHP.NET
 ****************************************************************************************************/
function AutoGal_DelDir($dirName)
{
    if(empty($dirName))
    {
       return;
    }
	
    if(file_exists($dirName))
    {
        $dir = opendir($dirName);
        while($file = readdir($dir))
        {
            if($file != '.' && $file != '..')
            {
                if(is_dir("$dirName/$file"))
                {
                    AutoGal_DelDir("$dirName/$file");
                }
                else
                {
                    if (!unlink("$dirName/$file")) return(str_replace('[FILE]', "$dirName/$file", AUTOGAL_LANG_ADMIN_FUNCTIONS_L113)."<br />");
                }
            }
        }
        closedir($dir);
        if (!rmdir($dirName)) 
        {
            return(AUTOGAL_LANG_ADMIN_FUNCTIONS_L111."rmdir \"$dirName\"<br />");
        }
    }
    else
    {
       return AUTOGAL_LANG_ADMIN_FUNCTIONS_L112."<br />";
    }
    return;
}

function AutoGal_DeleteElement($eleInfo)
{
	$element = $eleInfo['element'];
    $absElePath = $eleInfo['abspath'];
    $imgThumb = $eleInfo['imgthumbpath'];
    $text = "";
    
    if ($eleInfo['type'] == 'Image')
    {
        if (unlink($absElePath))
        {
            $text .= str_replace('[FILE]', $element, AUTOGAL_LANG_ADMIN_FUNCTIONS_L78)."<br />"; 
			
			AutoGal_AddAdminLog("ImageDeleted", AUTOGAL_LANG_ADMIN_FUNCTIONS_L79." \"$absElePath\".");
            
			// DELETE THUMB
            if ((file_exists($imgThumb))&&($imgThumb != $absElePath)&&(!$eleInfo['imgthumbunavail']))
            {
                if (unlink($imgThumb)){
                    $text .= str_replace('[THUMBNAIL]', basename($imgThumb), AUTOGAL_LANG_ADMIN_FUNCTIONS_L80)."<br />"; 
                }else{
                    $text .= "<b>".AUTOGAL_LANG_ADMIN_FUNCTIONS_L48."</b> ".str_replace('[THUMBNAIL]', basename($imgThumb), AUTOGAL_LANG_ADMIN_FUNCTIONS_L81)."<br />".AUTOGAL_LANG_ADMIN_FUNCTIONS_L82."$imgThumb<br />";     
                }
            }
        }
        else
        {
            $text .= "<b>".AUTOGAL_LANG_ADMIN_FUNCTIONS_L48."</b> ".str_replace('[FILE]', $element, AUTOGAL_LANG_ADMIN_FUNCTIONS_L83)."<br />".AUTOGAL_LANG_ADMIN_FUNCTIONS_L82."$absElePath<br />"; 
        }
    }
    else
    {
        if ($delError = AutoGal_DelDir($absElePath))
		{
            $text .= "<b>".AUTOGAL_LANG_ADMIN_FUNCTIONS_L48."</b> ".str_replace('[GALLERY]', $element, AUTOGAL_LANG_ADMIN_FUNCTIONS_L84)."<br />".AUTOGAL_LANG_ADMIN_FUNCTIONS_L82."$absElePath<br />".AUTOGAL_LANG_ADMIN_FUNCTIONS_L88."$delError<br />";     
        }else
		{
            $text .= str_replace('[GALLERY]', $element, AUTOGAL_LANG_ADMIN_FUNCTIONS_L85)."<br />";     
			AutoGal_AddAdminLog("GalleryDeleted", AUTOGAL_LANG_ADMIN_FUNCTIONS_L74." \"$absElePath\".");
        }
    }
	
	// DELETE XML META FILE
	if (file_exists($eleInfo['xmlfile']))
	{
		if (unlink($eleInfo['xmlfile'])){
			$text .= str_replace('[XMLFILE]', basename($eleInfo['xmlfile']), AUTOGAL_LANG_ADMIN_FUNCTIONS_L86)."<br />"; 
		}else{
			$text .= "<b>".AUTOGAL_LANG_ADMIN_FUNCTIONS_L48."</b> ".str_replace('[XMLFILE]', basename($eleInfo['xmlfile']), AUTOGAL_LANG_ADMIN_FUNCTIONS_L87)."<br />".AUTOGAL_LANG_ADMIN_FUNCTIONS_L82.$eleInfo['xmlfile']."<br />";     
		}
	}
    
    return ($text);
}

function AutoGal_PageMoveElements($selEleInfo, $eles)
{
	$element = $selEleInfo['element'];
	
	if ($_POST['ag_doit'])
	{
		$moveTo = rawurldecode($_POST['ag_moveloc']);
		
		foreach ($eles as $ele)
		{
			$text .= AutoGal_MoveElement($ele, $moveTo, $newEle);
		}
		
		if (($selEleInfo['element'] == $eles[0]['element'])&&(count($eles) == 1))
		{
			$backEle = $newEle;
		}
		else
		{
			$backEle = $selEleInfo;
		}
		
		$text .= "
		[<a href=\"".$backEle['backlink']."\">".AUTOGAL_LANG_ADMIN_EDIT_3.$backEle['filetypetitle']." '".($backEle['title'] ? $backEle['title'] : AUTOGAL_ROOTNAME)."'</a>]<br />";		
		
		return $text;
	}
	
	if ($eleInfo['type'] == 'Image'){
        $galSelect = AutoGal_GallerySelect(AutoGal_GetImageGallery($element), '', 0, 1);
    }else{
        $galSelect = AutoGal_GallerySelect(AutoGal_GetImageGallery($element), $element, 1, 1);
    }
		
	$text = "
	<br />
	<div style='text-align:center'>
	<b>".AUTOGAL_LANG_ADMIN_EDIT_38."</b><br />
	<br />
	<select name='ag_moveloc' class='tbox'>
	$galSelect
	</select><br />
	<br />
	<table class='border' style='width:97%'>
	<tr>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_5."</th>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_6."</th>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_39."</th>
	</tr>";
	
	foreach ($eles as $ele)
	{
		$thumbImg = ($ele['type'] == 'Gallery' ? $ele['defimghtml'] : $ele['imgthumbhtml']."<br />");
	
		$text .= "
		<tr>
			<td class='forumheader3' style='text-align:center'>".
				$ele['filetypetitle']."
			</td>
			<td class='forumheader3' style='text-align:center'>".
				($thumbImg ? $ele['ahref'].">".$thumbImg : '').
				$ele['ahref'].">".$ele['title']."</a>
			</td>
			<td class='forumheader3' style='text-align:center'>
				".$ele['fulltitle']."
			</td>
		</tr>";
	}
	
	$text .= "</table>
	<br />
	<input type='submit' class='button' name='ag_doit' value='".AUTOGAL_LANG_ADMIN_EDIT_37."'>
	<input type='button' class='button' value='".AUTOGAL_LANG_ADMIN_EDIT_15."' onclick='javascript:history.go(-1)'>
	</div>";
	
	return $text;
}

function AutoGal_MoveElement($eleInfo, $moveTo, &$newEleInfo)
{
	$element = $eleInfo['element'];
    $absElePath = $eleInfo['abspath'];
	$type = $eleInfo['type'];
    $toPath = AutoGal_GetAbsGalPath($moveTo).'/'.$eleInfo['basename'];
    $text = "";
	
	if ($toPath == $absElePath) return AUTOGAL_LANG_ADMIN_FUNCTIONS_L89."<br />";

    $moveToTitle = $eleInfo['pathtitle'];
            
    if (rename($absElePath, $toPath))
    {
		$msg = AUTOGAL_LANG_ADMIN_FUNCTIONS_L90;
		$msg = str_replace('[TYPE]', $type, $msg);
		$msg = str_replace('[FILE]', $eleInfo['basename'], $msg);
		$msg = str_replace('[GALLERY]', $moveToTitle, $msg);
        $text .= "$msg (<a href=\"".AUTOGAL_AUTOGALLERY."?show=".rawurlencode($moveTo)."\">".AUTOGAL_LANG_ADMIN_FUNCTIONS_L91."</a>).<br />";
        $newEleInfo = AutoGal_GetElementInfo(AutoGal_GetElement($toPath), true);
		
		AutoGal_AddAdminLog("${type}Moved", AUTOGAL_LANG_ADMIN_FUNCTIONS_L92." \"$absElePath\" ".AUTOGAL_LANG_ADMIN_FUNCTIONS_L93." \"$toPath\".");
		
		// MOVE XML FILE
		if (file_exists($eleInfo['xmlfile']))
		{
			if (rename($eleInfo['xmlfile'], $toPath.'.xml')){
				$text .= str_replace('[XMLFILE]', basename($eleInfo['xmlfile']), AUTOGAL_LANG_ADMIN_FUNCTIONS_L94)."<br />"; 
			}else{
				$text .= "<b>".AUTOGAL_LANG_ADMIN_FUNCTIONS_L48."</b> ".str_replace('[XMLFILE]', basename($eleInfo['xmlfile']), AUTOGAL_LANG_ADMIN_FUNCTIONS_L95)."<br />".AUTOGAL_LANG_ADMIN_FUNCTIONS_L82.$eleInfo['xmlfile']."<br />";     
			}
		}
		
        if ($type == 'Image')
        {
			if (!$eleInfo['imgthumbunavail'])
			{
				$imgThumb = $eleInfo['imgthumbpath'];
				$pathInfo = pathinfo($toPath);
				$extInfo = pathinfo($imgThumb);
				$newThumb = $pathInfo['dirname'].'/'.AUTOGAL_THUMBPREFIX.$pathInfo['basename'].($eleInfo['isnonimg'] ? '.'.$extInfo['extension'] : '');
												
				if ((file_exists($imgThumb))&&($imgThumb != $absElePath))
				{
					if (rename ($imgThumb, $newThumb)){   
						$text .= str_replace('[THUMB]', basename($imgThumb), str_replace('[GALLERY]', $moveToTitle, AUTOGAL_LANG_ADMIN_FUNCTIONS_L98))."<br />";       
					}else{
						$text .= "<b>".AUTOGAL_LANG_ADMIN_FUNCTIONS_L48."</b> ".str_replace('[THUMB]', basename($imgThumb), str_replace('[GALLERY]', $moveToTitle, AUTOGAL_LANG_ADMIN_FUNCTIONS_L99))."<br />".
						AUTOGAL_LANG_ADMIN_FUNCTIONS_L97."$imgThumb<br />".AUTOGAL_LANG_ADMIN_FUNCTIONS_L96."$toThumbPath<br />";    
					}
				}
			}
        }
    }
    else
    {
		$msg = AUTOGAL_LANG_ADMIN_FUNCTIONS_L100;
		$msg = str_replace('[TYPE]', $type, $msg);
		$msg = str_replace('[FILE]', $eleInfo['basename'], $msg);
		$msg = str_replace('[GALLERY]', $moveToTitle, $msg);
		
        $text .= "<b>".AUTOGAL_LANG_ADMIN_FUNCTIONS_L48."</b> $msg<br />".
		AUTOGAL_LANG_ADMIN_FUNCTIONS_L97."$absElePath<br />".AUTOGAL_LANG_ADMIN_FUNCTIONS_L96."$toPath<br />";    
    } 
    
    return ("$text<br />");
}

function AutoGal_PageSetDefaultImage($selEleInfo, $eles)
{
	if ($selEleInfo['isroot'])
	{
		return "<div style='text-align:center'>".AUTOGAL_LANG_ADMIN_EDIT_36."</div>";
	}
	
	if ($selEleInfo['type'] != 'Gallery')
	{
		return "<div style='text-align:center'>".AUTOGAL_LANG_ADMIN_EDIT_35."</div>";
	}
	
	if (count($eles) != 1)
	{
		return "<div style='text-align:center'>".AUTOGAL_LANG_ADMIN_EDIT_34."</div>";
	}
	
	$defImg = $eles[0];
	
	if ($defImg['element'] == $selEleInfo['element'])
	{
		return "<div style='text-align:center'>".AUTOGAL_LANG_ADMIN_EDIT_33."</div>";
	}
	
	if ($defImg['type'] == 'Gallery')
	{
		return "<div style='text-align:center'>".AUTOGAL_LANG_ADMIN_EDIT_32."</div>";
	}
	
	if ($_POST['ag_doit'])
	{
		$text .= AutoGal_SetDefaultImage($defImg);

		$text .= "
		<br />
		[<a href=\"".$selEleInfo['backlink']."\">".AUTOGAL_LANG_ADMIN_EDIT_3.$selEleInfo['filetypetitle']." '".($selEleInfo['title'] ? $selEleInfo['title'] : AUTOGAL_ROOTNAME)."'</a>]<br />";		
		
		return $text;
	}
	
	$text = "
	<br />
	<div style='text-align:center'>
	<b>".AUTOGAL_LANG_ADMIN_EDIT_31."'".$selEleInfo['ahref'].">".$selEleInfo['title']."</a>'?</b><br />
	<br />".
	($defImg['imgthumbhtml'] ? $defImg['ahref'].">".$defImg['imgthumbhtml']."<br />" : '').
	$defImg['ahref'].">".$defImg['title']."</a><br />
	<br />
	<input type='submit' class='button' name='ag_doit' value='".AUTOGAL_LANG_ADMIN_EDIT_29."'>
	<input type='button' class='button' value='".AUTOGAL_LANG_ADMIN_EDIT_30."' onclick='javascript:history.go(-1)'>";
		
	return $text;
	
}

function AutoGal_SetDefaultImage($eleInfo)
{
	$element = $eleInfo['element'];
	$gallery = $eleInfo['gallery'];
	AutoGal_GetDefaultImage($gallery, $origDefImg);
	$origDefImgInfo = pathinfo($origDefImg);
	$imgThumb = $eleInfo['imgthumbpath'];
	$text = '';
	
	if ($origDefImg)
	{
		$origDefImgNewPath = AutoGal_GetAbsGalPath($gallery)."/".AUTOGAL_LANG_ADMIN_FUNCTIONS_L60."(".time().").".$origDefImgInfo['extension'];
		if (!rename($origDefImg, $origDefImgNewPath))
		{
			return "<b>".AUTOGAL_LANG_ADMIN_FUNCTIONS_L48."</b> ".str_replace('[ORIGIMG]', $origDefImg, str_replace('[NEWIMG]', $origDefImgNewPath, AUTOGAL_LANG_ADMIN_FUNCTIONS_L61));
		}
		else
		{
			$text = AUTOGAL_LANG_ADMIN_FUNCTIONS_L62."\"".basename($origDefImgNewPath)."\"<br />";
			AutoGal_AddAdminLog("RemoveDefaultImage", "Image \"$origDefImgNewPath\".");
		}
		
		if ((file_exists($imgThumb))&&($imgThumb != $absElePath))
		{
			if (unlink($imgThumb)){
				$text .= str_replace('[IMGTHUMB]', basename($imgThumb), AUTOGAL_LANG_ADMIN_FUNCTIONS_L63)."<br />"; 
			}else{
				$text .= "<b>".AUTOGAL_LANG_ADMIN_FUNCTIONS_L48."</b> ".str_replace('[IMGTHUMB]', basename($imgThumb), AUTOGAL_LANG_ADMIN_FUNCTIONS_L64)."<br />".AUTOGAL_LANG_ADMIN_FUNCTIONS_L65."$imgThumb<br />";     
			}
		}
	}
	
	$newDefImgPath = AutoGal_GetAbsGalPath($gallery).'/'.AUTOGAL_DEFAULTIMAGE.'.'.strtolower($eleInfo['extension']);
	$eleAbsPath = $eleInfo['abspath'];
	if (rename($eleAbsPath, $newDefImgPath))
	{
		$text .= str_replace('[IMAGE]', $element, AUTOGAL_LANG_ADMIN_FUNCTIONS_L66)."<br />";
		AutoGal_AddAdminLog("SetDefaultImage", AUTOGAL_LANG_ADMIN_FUNCTIONS_L67."\"$eleAbsPath\".");
	}
	else
	{
		$text .= "<b>".AUTOGAL_LANG_ADMIN_FUNCTIONS_L48."</b> ".str_replace('[ORIGIMG]', $eleAbsPath, str_replace('[NEWIMG]', $newDefImgPath, AUTOGAL_LANG_ADMIN_FUNCTIONS_L61))."<br />";
	}

	return $text;
}

function AutoGal_PageCreateGallery($selEleInfo, $eles)
{
	$maxGalleries = 5;
	
	if ($selEleInfo['type'] != 'Gallery')
	{
		$text = " 
		<div style='text-align:center'>
		<br />
		<b>".AUTOGAL_LANG_ADMIN_EDIT_28."</b><br />
		<br />
		<input type='button' class='button' value='".AUTOGAL_LANG_ADMIN_EDIT_12."' onclick='javascript:history.go(-1)'>
		</div>";
	}
 	
	if ($_POST['ag_doit'])
	{
		foreach ($_POST as $postVar => $postVal)
		{
			if ((preg_match("/^ag_newgallery_(\d+)$/", $postVar))&&($postVal))
			{
				$newGalleryName = $postVal;
				$text .= AutoGal_CreateGallery($selEleInfo, $newGalleryName);
			}
		}
		
		if ($text)
		{
			$text .= "<br />
			[<a href=\"".$selEleInfo['backlink']."\">".AUTOGAL_LANG_ADMIN_EDIT_3.$selEleInfo['filetypetitle']." '".($selEleInfo['title'] ? $selEleInfo['title'] : AUTOGAL_ROOTNAME)."'</a>]<br />";		
		
			return $text;
		}
		else
		{
			$text .= "<div style='text-align:center'>".AUTOGAL_LANG_ADMIN_EDIT_27."<br /></div>";
		}
	}
	
	$text .= "
	<br />
	<div style='text-align:center'>
	<b>".AUTOGAL_LANG_ADMIN_EDIT_25."'".($selEleInfo['isroot'] ? AUTOGAL_ROOTNAME : $selEleInfo['title'])."':</b><br />
	<span class='smalltext'>".AUTOGAL_LANG_ADMIN_EDIT_26."</span><br />
	<br />";
	
	for ($textBoxI = 0; $textBoxI < $maxGalleries; $textBoxI ++)
	{
		$text .= ($textBoxI + 1).". <input type='text' class='tbox' size='50' name='ag_newgallery_$textBoxI'><br /><br />";
	}
	
	$text .= "
	<input type='submit' class='button' name='ag_doit' value='".AUTOGAL_LANG_ADMIN_EDIT_23."'>
	<input type='button' class='button' value='".AUTOGAL_LANG_ADMIN_EDIT_15."' onclick='javascript:history.go(-1)'>";
	
	return $text;
}

function AutoGal_CreateGallery($inGalInfo, $newGalleryName, &$newElement)
{
	$inGallery = $inGalInfo['element'];
	
	if ($illegalChars = AutoGal_IsIllegalName($newGalleryName))
    {
        $message = str_replace('[CHARS]', $illegalChars, AUTOGAL_LANG_ADMIN_FUNCTIONS_L70)."<br />";
    }
    else
    {
		$parGalAbsPath = AutoGal_GetAbsGalPath($inGallery ? "$inGallery/" : '');
        $newGalleryPath = $parGalAbsPath.'/'.$newGalleryName;
		$newGalleryPath = str_replace('//', '/', $newGalleryPath);
        
        if ((mkdir($newGalleryPath))&&(touch("$newGalleryPath/index.html")))
        {
            $newElement = AutoGal_GetElement($newGalleryPath);
			$parentGal = ($inGallery ? AUTOGAL_LANG_ADMIN_FUNCTIONS_L71." \"$inGallery\"" : AUTOGAL_LANG_ADMIN_FUNCTIONS_L72);
			
			$message = str_replace('[GALLERY]', $newGalleryName, str_replace('[PARENT]', $parentGal, AUTOGAL_LANG_ADMIN_FUNCTIONS_L73))."<br />";                
			
			AutoGal_AddAdminLog("GalleryCreated", AUTOGAL_LANG_ADMIN_FUNCTIONS_L74."\"$newGalleryPath\".");
			
			if (chmod($newGalleryPath, 0777)){
                $message .= str_replace('[GALLERY]', $newGalleryName, AUTOGAL_LANG_ADMIN_FUNCTIONS_L75)."<br />";
            }else{
                $message .= AUTOGAL_LANG_ADMIN_FUNCTIONS_L48." ".str_replace('[GALLERY]', $newGalleryName, AUTOGAL_LANG_ADMIN_FUNCTIONS_L76)."<br />";
            }
			
			$newEleInfo = AutoGal_GetElementInfo($newElement);
			$message .= AutoGal_ChangeGalleryUserClass($newEleInfo, 'view',     $inGalInfo['viewclass'],     $newEleInfo);
			$message .= AutoGal_ChangeGalleryUserClass($newEleInfo, 'upload',   $inGalInfo['uploadclass'],   $newEleInfo);
			$message .= AutoGal_ChangeGalleryUserClass($newEleInfo, 'admin',    $inGalInfo['adminclass'],    $newEleInfo);
			$message .= AutoGal_ChangeGalleryUserClass($newEleInfo, 'mcomment', $inGalInfo['mcommentclass'], $newEleInfo);
			$message .= AutoGal_ChangeGalleryUserClass($newEleInfo, 'gcomment', $inGalInfo['gcommentclass'], $newEleInfo);
        }
        else
        {
			$parentGal = ($inGallery ? AUTOGAL_LANG_ADMIN_FUNCTIONS_L71." \"$inGallery\"" : AUTOGAL_LANG_ADMIN_FUNCTIONS_L72);
            $message = AUTOGAL_LANG_ADMIN_FUNCTIONS_L48." ".str_replace('[GALLERY]', $newGalleryPath, str_replace('[PARENT]', $parGalAbsPath, AUTOGAL_LANG_ADMIN_FUNCTIONS_L77))."<br />";                
        }
    }
    
    return ($message);
}

function AutoGal_PageChangeUserClasses($selEleInfo, $eles)
{
	if ($_POST['ag_doit'])
	{
		foreach ($eles as $ele)
		{
			$ele = AutoGal_GetElementInfo($ele['element'], true);
			
			$eleVarName = preg_replace("/[\.\s]/", '_', urlencode($ele['element']));
			$ucView = $_POST["ag_ucview_".$eleVarName];
			$ucUpload = $_POST["ag_ucupload_".$eleVarName];
			$ucAdmin = $_POST["ag_ucadmin_".$eleVarName];
			$ucGComment = $_POST["ag_ucgcomment_".$eleVarName];
			$ucMComment = $_POST["ag_ucmcomment_".$eleVarName];

			if ($ele['viewclass'] != $ucView) $text .= AutoGal_ChangeGalleryUserClass($ele, 'view', $ucView, $newEle);
			if ($ele['uploadclass'] != $ucUpload) $text .= AutoGal_ChangeGalleryUserClass($ele, 'upload', $ucUpload, $newEle);
			if ($ele['adminclass'] != $ucAdmin) $text .= AutoGal_ChangeGalleryUserClass($ele, 'admin', $ucAdmin, $newEle);
			if ($ele['gcommentclass'] != $ucGComment) $text .= AutoGal_ChangeGalleryUserClass($ele, 'gcomment', $ucGComment, $newEle);
			if ($ele['mcommentclass'] != $ucMComment) $text .= AutoGal_ChangeGalleryUserClass($ele, 'mcomment', $ucMComment, $newEle);
		}
		
		if ($text)
		{
			$text .= "<br />
			[<a href=\"".$selEleInfo['backlink']."\">".AUTOGAL_LANG_ADMIN_EDIT_3.$selEleInfo['filetypetitle']." '".($selEleInfo['title'] ? $selEleInfo['title'] : AUTOGAL_ROOTNAME)."'</a>]<br />";		
		
			return $text;
		}
		else
		{
			$text .= "<div style='text-align:center'>".AUTOGAL_LANG_ADMIN_EDIT_22."<br /></div>";
		}
	}
	
	foreach ($eles as $ele)
	{
		$ele = AutoGal_GetElementInfo($ele['element'], true);
		$thumbImg = $ele['defimghtml'];
		if ($ele['type'] == 'Image') continue;
	
		$galleryRows .= "
		<tr>
			<td class='forumheader3' style='text-align:center'>".
				($thumbImg ? $ele['ahref'].">".$thumbImg."<br />" : '').
				$ele['ahref'].">".$ele['title']."</a>
			</td>
			<td class='forumheader3' style='text-align:center'>
				".r_userclass("ag_ucview_".urlencode($ele['element']), $ele['viewclass'], 'off', 'public,member,guest,admin,classes,nobody,classes')."
			</td>
			<td class='forumheader3' style='text-align:center'>
				".r_userclass("ag_ucupload_".urlencode($ele['element']), $ele['uploadclass'], 'off', 'public,member,guest,admin,classes,nobody,classes')."
			</td>
			<td class='forumheader3' style='text-align:center'>
				".r_userclass("ag_ucadmin_".urlencode($ele['element']), $ele['adminclass'], 'off', 'public,member,guest,admin,classes,nobody,classes')."
			</td>
			<td class='forumheader3' style='text-align:center'>
				".r_userclass("ag_ucgcomment_".urlencode($ele['element']), $ele['gcommentclass'], 'off', 'public,member,guest,admin,classes,nobody,classes')."
			</td>
			<td class='forumheader3' style='text-align:center'>
				".r_userclass("ag_ucmcomment_".urlencode($ele['element']), $ele['mcommentclass'], 'off', 'public,member,guest,admin,classes,nobody,classes')."
			</td>
		</tr>";
	}
	
	if ($galleryRows)
	{
		$text .= "
		<br />
		<div style='text-align:center'>
		<table class='border' style='width:97%'>
		<tr>
			<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_16."</th>
			<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_17."</th>
			<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_18."</th>
			<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_19."</th>
			<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_20."</th>
			<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_21."</th>
		</tr>
		$galleryRows
		</table>
		<br />
		<input type='submit' class='button' name='ag_doit' value='".AUTOGAL_LANG_ADMIN_EDIT_14."'>
		<input type='button' class='button' value='".AUTOGAL_LANG_ADMIN_EDIT_15."' onclick='javascript:history.go(-1)'>
		</div>";
	}
	else
	{
		$text = " 
		<div style='text-align:center'>
		<br />
		<b>".AUTOGAL_LANG_ADMIN_EDIT_13."</b><br />
		<br />
		<input type='button' class='button' value='".AUTOGAL_LANG_ADMIN_EDIT_12."' onclick='javascript:history.go(-1)'>
		</div>";
	}
	
	return $text;
}

function AutoGal_PageChangeDescription($selEleInfo, $eles)
{
	if (!AUTOGAL_USEXMLMETA) return "XML has been turned off";
	
	if ($_POST['ag_doit'])
	{
		foreach ($eles as $eleI => $ele)
		{
			$ele = AutoGal_GetElementInfo($ele['element'], true);
			$eleVarName = preg_replace("/[\.\s]/", '_', urlencode($ele['element']));
			$newDesc = $_POST["ag_desc_".$eleVarName];
			
			$newDesc = preg_replace("/\r/", '', $newDesc);
	
			if ($newDesc != $ele['description'])
			{
				$text .= AutoGal_MetaChangeDescription($ele, $newDesc, $newEle);
			}
		}
		
		if ($text)
		{
			$text .= "<br />
			[<a href=\"".$selEleInfo['backlink']."\">".AUTOGAL_LANG_ADMIN_EDIT_3.$selEleInfo['filetypetitle']." '".($selEleInfo['title'] ? $selEleInfo['title'] : AUTOGAL_ROOTNAME)."'</a>]<br />";		
		
			return $text;
		}
		else
		{
			$text .= "<div style='text-align:center'>".AUTOGAL_LANG_ADMIN_EDIT_11."<br /></div>";
		}
	}
		
	$text .= "
	<br />
	<div style='text-align:center'>
	<table class='border' style='width:97%'>
	<tr>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_5."</th>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_6."</th>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_10."</th>
	</tr>";
	
	foreach ($eles as $ele)
	{
		$ele = AutoGal_GetElementInfo($ele['element'], true);
		$thumbImg = ($ele['type'] == 'Gallery' ? $ele['defimghtml'] : $ele['imgthumbhtml']."<br />");
	
		$text .= "
		<tr>
			<td class='forumheader3' style='text-align:center'>".
				$ele['filetypetitle']."
			</td>
			<td class='forumheader3' style='text-align:center'>".
				($thumbImg ? $ele['ahref'].">".$thumbImg : '').
				$ele['ahref'].">".$ele['title']."</a>
			</td>
			<td class='forumheader3' style='text-align:center'>
				<textarea name=\"ag_desc_".urlencode($ele['element'])."\" class='tbox' cols='70' rows='5'>".$ele['description']."</textarea>
			</td>
		</tr>";
	}
	
	$text .= "</table>
	<br />
	<input type='submit' class='button' name='ag_doit' value='".AUTOGAL_LANG_ADMIN_EDIT_24."'>
	<input type='button' class='button' value='".AUTOGAL_LANG_ADMIN_EDIT_15."' onclick='javascript:history.go(-1)'>
	</div>";
	
	return $text;
}

function AutoGal_MetaChangeDescription($eleInfo, $newDesc, &$newEleInfo)
{
	if (!AUTOGAL_USEXMLMETA) return;
	
	$eleInfo['description'] = $newDesc;
	$title = ($eleInfo['title'] ? $eleInfo['title'] : AUTOGAL_ROOTNAME);
	if (!AutoGal_SetElementInfo($eleInfo, 0, $errMsg))
	{
		$text = $eleInfo['filetypetitle']." '$title': <b>".AUTOGAL_LANG_ADMIN_FUNCTIONS_L48."</b> ".AUTOGAL_LANG_ADMIN_FUNCTIONS_L116."<br />$errMsg<br />";
	}
	else
	{
		$text = $eleInfo['filetypetitle']." '$title': ".AUTOGAL_LANG_ADMIN_FUNCTIONS_L117."<br />";
		$newEleInfo = $eleInfo;
	}
	
	return $text;
}

/*****************************************************************************************************
 * 
 ****************************************************************************************************/
function AutoGal_RenameElement($eleInfo, $newTitle, $newNum, &$newEleInfo)
{
    $element = $eleInfo['element'];
    $absElePath = $eleInfo['abspath'];
    $eleExt = $eleInfo['appext'];
    $type = $eleInfo['type'];
    $renameTo = ($newNum >= 1 ? $newNum.'.' : '').($eleInfo['type'] == 'Image' ? str_replace(' ', '_', $newTitle) : $newTitle);
	
	$renameTo = str_replace("\\", '', $renameTo);
    $renameToPath = dirname($absElePath).'/'.$renameTo.$eleExt;
	
    $text = '';            
	$illegalChars = AutoGal_IsIllegalName($renameTo);
    if ($illegalChars)
    {
		$msg = AUTOGAL_LANG_ADMIN_FUNCTIONS_L101;
		$msg = str_replace('[TYPE]', $type, $msg);
		$msg = str_replace('[FILE]', $renameTo, $msg);
		$msg = str_replace('[CHARS]', $illegalChars, $msg);
        $text .= "<b>".AUTOGAL_LANG_ADMIN_FUNCTIONS_L48."</b> $msg<br />";
    }
	elseif(rename($absElePath, $renameToPath))
	{ 
		$msg = AUTOGAL_LANG_ADMIN_FUNCTIONS_L102;
		$msg = str_replace('[TYPE]', $eleInfo['filetypetitle'], $msg);
		$msg = str_replace('[FROMNAME]', $eleInfo['basename'], $msg);
		$msg = str_replace('[TONAME]', basename($renameToPath), $msg);
        $text .= "$msg<br />";
		$newEleInfo = AutoGal_GetElementInfo(AutoGal_GetElement($renameToPath), true);
		
		AutoGal_AddAdminLog("${type}Renamed", AUTOGAL_LANG_ADMIN_FUNCTIONS_L92." \"$absElePath\" ".AUTOGAL_LANG_ADMIN_FUNCTIONS_L93." \"$renameToPath\".");
		
		// RENAME XML META FILE
		if (file_exists($eleInfo['xmlfile']))
		{
			if (rename($eleInfo['xmlfile'], $renameToPath.'.xml')){
				$text .= "XML Meta File \"".basename($eleInfo['xmlfile'])."\" Successfully Renamed!<br />"; 
			}else{
				$text .= "<b>".AUTOGAL_LANG_ADMIN_FUNCTIONS_L48."</b> XML Meta File \"".basename($eleInfo['xmlfile'])."\" Could not be Renamed!<br />Full Path: ".$eleInfo['xmlfile']."<br />";     
			}
		}
        		
        if ($type == 'Image')
        {
			if (!$eleInfo['imgthumbunavail'])
			{
				$imgThumb = $eleInfo['imgthumbpath'];
				$pathInfo = pathinfo($renameToPath);
				$extInfo = pathinfo($imgThumb);
				$newThumb = AUTOGAL_THUMBPREFIX.$pathInfo['basename'].($eleInfo['isnonimg'] ? '.'.$extInfo['extension'] : '');
				$renameThumbToPath = dirname($absElePath).'/'.$newThumb;
				
				if ((file_exists($imgThumb))&&($imgThumb != $absElePath))
				{
					if (rename ($imgThumb, $renameThumbToPath))
					{
						$text .= str_replace('[FROMTHUMB]', basename($imgThumb), str_replace('[TOTHUMB]', $newThumb, AUTOGAL_LANG_ADMIN_FUNCTIONS_L103))."<br />";
						$imgThumb = $renameThumbToPath;
					}
					else
					{
						$text .= "<b>".AUTOGAL_LANG_ADMIN_FUNCTIONS_L48."</b> ".str_replace('[FROMTHUMB]', basename($imgThumb), str_replace('[TOTHUMB]', $newThumb, AUTOGAL_LANG_ADMIN_FUNCTIONS_L104))."<br />".
						AUTOGAL_LANG_ADMIN_FUNCTIONS_L97."$imgThumb<br />".AUTOGAL_LANG_ADMIN_FUNCTIONS_L96."$renameThumbToPath<br />";
					}
				}
			}
        }
        
        $element = (basename($element) ? basename($element).'/' : '').$renameTo;
    }
    else
    {
		$msg = AUTOGAL_LANG_ADMIN_FUNCTIONS_L105;
		$msg = str_replace('[TYPE]', $type, $msg);
		$msg = str_replace('[FROMNAME]', $eleTitle, $msg);
		$msg = str_replace('[TONAME]', $renameTo, $msg);
        $text .= "<br /><b>".AUTOGAL_LANG_ADMIN_FUNCTIONS_L48."</b> $msg<br />".
		AUTOGAL_LANG_ADMIN_FUNCTIONS_L97."$absElePath<br />".AUTOGAL_LANG_ADMIN_FUNCTIONS_L96."$renameToPath<br />";    
    }
	
    return ("$text<br />");
}

function AutoGal_PageWatermark($eleInfo, $eles)
{
	global $pref;
	
	if (isset($_POST['ag_wmimage']))
	{
		$opts['ag_wmimage'] = $_POST['ag_wmimage'];
		$opts['ag_wmintensity'] = $_POST['ag_wmintensity'];
		$opts['ag_wmxalign'] = $_POST['ag_wmxalign'];
		$opts['ag_wmyalign'] = $_POST['ag_wmyalign'];
		$opts['ag_wmxoffset'] = $_POST['ag_wmxoffset'];
		$opts['ag_wmyoffset'] = $_POST['ag_wmyoffset'];
	}
	else
	{
		$opts['ag_wmimage'] = $pref['autogal_wmarkimage'];
		$opts['ag_wmintensity'] = $pref['autogal_wmarkintensity'];
		$opts['ag_wmxalign'] = $pref['autogal_wmarkxalign'];
		$opts['ag_wmyalign'] = $pref['autogal_wmarkyalign'];
		$opts['ag_wmxoffset'] = $pref['autogal_wmarkxoffset'];
		$opts['ag_wmyoffset'] = $pref['autogal_wmarkyoffset'];
	}
	
	$opts['ag_wmintensity'] = (preg_match("/^[0-9]+$/", $opts['ag_wmintensity']) ? $opts['ag_wmintensity'] : 30);
	$opts['ag_wmxoffset'] = (preg_match("/^[0-9]+$/", $opts['ag_wmxoffset']) ? $opts['ag_wmxoffset'] : 0);
	$opts['ag_wmyoffset'] = (preg_match("/^[0-9]+$/", $opts['ag_wmyoffset']) ? $opts['ag_wmyoffset'] : 0);
		
	foreach ($eles as $ele)
	{
		if ($ele['type'] == 'Gallery') continue;
		if (!$ele['isimage']) continue;
		
		$okEles[] = $ele;
		
		$imageTable .= "
		<tr>
			<td class='forumheader3' style='text-align:center'>".
				($ele['imgthumbhtml'] ? $ele['ahref'].">".$ele['imgthumbhtml']."<br />" : '')."
			</td>
			<td class='forumheader3' style='text-align:center'>
				".$ele['fulltitle']."
			</td>
		</tr>";
	}
	
	if (!$imageTable)
	{
		$text = " 
		<div style='text-align:center'>
		<br />
		".AUTOGAL_LANG_ADMIN_EDIT_45."<br />
		<br />
		<input type='button' class='button' value='".AUTOGAL_LANG_ADMIN_EDIT_12."' onclick='javascript:history.go(-1)'>
		</div>";
		
		return $text;
	}
	
	if ($_POST['ag_doit'])
	{
		# DO THE WATERMARKING
		$text = "<div style='text-align:left'>";
	
		require_once(AUTOGAL_IMGMANIPHANDLER);

		$mode = $pref['resize_method'];
		$imPath = $pref['im_path'];
		$gdim = new GDIM($mode, $imPath);
		
		$wmOpts = array
		(
			'intensity' => $opts['ag_wmintensity'], 
			'xalign' => $opts['ag_wmxalign'], 
			'yalign' => $opts['ag_wmyalign'], 
			'xoffset' => $opts['ag_wmxoffset'], 
			'yoffset' => $opts['ag_wmyoffset'],
		);
	
		$wmImage = AUTOGAL_WATERMARKDIRABS."/".$opts['ag_wmimage'];
		
		foreach ($okEles as $ele)
		{
			$image = $ele['abspath'];
			$basename = $ele['basename'];
			
			if ($gdim->watermark($image, $image, $wmImage, $wmOpts))
			{
				$text .= $basename.': '.AUTOGAL_LANG_ADMIN_EDIT_48." (".$ele['ahref'].">".AUTOGAL_LANG_ADMIN_EDIT_50."</a>)<br />";
				AutoGal_AddAdminLog("ManualWatermark", AUTOGAL_LANG_ADMIN_FUNCTIONS_L79." \"".$image."\", ".AUTOGAL_LANG_ADMIN_EDIT_79."\"".basename($wmImage)."\"");
			}
			else
			{
				$text .= $basename.": <font color='red'>".AUTOGAL_LANG_ADMIN_EDIT_49."<font> - ".$gdim->lastError()."<br />";
			}
		}
		
		$text .= "<br />
		[<a href=\"".$eleInfo['backlink']."\">".AUTOGAL_LANG_ADMIN_EDIT_3.$eleInfo['filetypetitle']." '".($eleInfo['title'] ? $eleInfo['title'] : AUTOGAL_ROOTNAME)."'</a>]<br />
		</div>";
		
		return $text;
	}
	
	# GET LIST OF WATERMARKS
	$dh = opendir(AUTOGAL_WATERMARKDIRABS);
	while ($file = readdir($dh))
	{
		if (!AutoGal_IsImage($file)) continue;
		if (!$firstWMark) $firstWMark = $file;
		$wmImageOpts .= "<option value=\"".rawurlencode($file)."\"".($file == $opts['ag_wmimage'] ? " selected='selected'" : '').">$file</option>";
	}
	
	$selWMarkImg = ($opts['ag_wmimage'] ? $opts['ag_wmimage'] : $firstWMark);
	if ($selWMarkImg)
	{
		$selWMarkUrl = AUTOGAL_WATERMARKDIR."/$selWMarkImg";
	}

	$wmSettTable =  "
	<table class='border' width='97%'>
	<tr>
		<td style='width:50%' class='forumheader3'><b>".AUTOGAL_LANG_ADMIN_WATERMARK_3."</b><br /><span class='smalltext'>".str_replace("[DIR]", AUTOGAL_WATERMARKDIRABS, AUTOGAL_LANG_ADMIN_WATERMARK_4)."</span></td>
		<td style='width:50%' class='forumheader3'><select class='tbox' name='ag_wmimage' onchange='javascript:form.submit()'>$wmImageOpts</select>".($selWMarkUrl ? "<br /><br /><img src=\"$selWMarkUrl \" style='border:0' />" : '')."</td>
	</tr>
	<tr>
		<td style='width:50%' class='forumheader3'><b>".AUTOGAL_LANG_ADMIN_WATERMARK_5."</b><br /><span class='smalltext'>".AUTOGAL_LANG_ADMIN_WATERMARK_6."</span></td>
		<td style='width:50%' class='forumheader3'><input type='text' class='tbox' name='ag_wmintensity' size='3' value=\"".$opts['ag_wmintensity']."\"></td>
	</tr>
	<tr>
		<td style='width:50%' class='forumheader3'><b>".AUTOGAL_LANG_ADMIN_WATERMARK_7."</b><br /><span class='smalltext'>".AUTOGAL_LANG_ADMIN_WATERMARK_8."</span></td>
		<td style='width:50%' class='forumheader3'>
			<select name='ag_wmyalign' class='tbox'>
			<option value='t'".($opts['ag_wmyalign'] == 't' ? " selected='selected'" : '').">".AUTOGAL_LANG_ADMIN_WATERMARK_9."</option>
			<option value='m'".($opts['ag_wmyalign'] == 'm' ? " selected='selected'" : '').">".AUTOGAL_LANG_ADMIN_WATERMARK_10."</option>
			<option value='b'".($opts['ag_wmyalign'] == 'b' ? " selected='selected'" : '').">".AUTOGAL_LANG_ADMIN_WATERMARK_11."</option>
			</select>
			&nbsp;
			<select name='ag_wmxalign' class='tbox'>
			<option value='l'".($opts['ag_wmxalign'] == 'l' ? " selected='selected'" : '').">".AUTOGAL_LANG_ADMIN_WATERMARK_12."</option>
			<option value='c'".($opts['ag_wmxalign'] == 'c' ? " selected='selected'" : '').">".AUTOGAL_LANG_ADMIN_WATERMARK_13."</option>
			<option value='r'".($opts['ag_wmxalign'] == 'r' ? " selected='selected'" : '').">".AUTOGAL_LANG_ADMIN_WATERMARK_14."</option>
			</select>
		</td>
	</tr>
	<tr>
		<td style='width:50%' class='forumheader3'><b>".AUTOGAL_LANG_ADMIN_WATERMARK_15."</b><br /><span class='smalltext'>".AUTOGAL_LANG_ADMIN_WATERMARK_16."</span></td>
		<td style='width:50%' class='forumheader3'>
			X: <input type='text' class='tbox' name='ag_wmxoffset' size='3' value=\"".$opts['ag_wmxoffset']."\"> 
			Y: <input type='text' class='tbox' name='ag_wmyoffset' size='3' value=\"".$opts['ag_wmyoffset']."\">
		<td>
	</tr>
	</table>";
	
	$text = "
	<br />
	<div style='text-align:center'>
	<b>".AUTOGAL_LANG_ADMIN_EDIT_42."</b><br />
	<span class='smalltext'>".AUTOGAL_LANG_ADMIN_EDIT_43."</span><br />
	<br />
	$wmSettTable<br />
	<table class='border' style='width:97%'>
	<tr>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_46."</th>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_39."</th>
	</tr>
	$imageTable
	</table>
	<br />
	<input type='submit' class='button' name='ag_doit' value='".AUTOGAL_LANG_ADMIN_EDIT_47."'>
	<input type='button' class='button' value='".AUTOGAL_LANG_ADMIN_EDIT_30."' onclick='javascript:history.go(-1)'>
	</div>";
	
	return $text;
}

function AutoGal_PageRotate($eleInfo, $eles)
{
	global $pref;
	
	foreach ($eles as $ele)
	{
		if ($ele['type'] == 'Gallery') continue;
		if (!$ele['isimage']) continue;
		
		$okEles[] = $ele;
		
		$imageTable .= "
		<tr>
			<td class='forumheader3' style='text-align:center'>".
				($ele['imgthumbhtml'] ? $ele['ahref'].">".$ele['imgthumbhtml']."<br />" : '')."
			</td>
			<td class='forumheader3' style='text-align:center'>
				".$ele['fulltitle']."
			</td>
		</tr>";
	}
	
	if (!$imageTable)
	{
		$text = " 
		<div style='text-align:center'>
		<br />
		".AUTOGAL_LANG_ADMIN_EDIT_45."<br />
		<br />
		<input type='button' class='button' value='".AUTOGAL_LANG_ADMIN_EDIT_12."' onclick='javascript:history.go(-1)'>
		</div>";
		
		return $text;
	}
	
	if ($_POST['ag_doit'])
	{
		# DO THE ROTATING
		$text = "<div style='text-align:left'>";
	
		require_once(AUTOGAL_IMGMANIPHANDLER);

		$mode = $pref['resize_method'];
		$imPath = $pref['im_path'];
		$gdim = new GDIM($mode, $imPath);
		$angle = $_POST['ag_angle'];
		if (($angle != 90)&&($angle != 180)&&($angle != 270)) $angle = 90;
		
		foreach ($okEles as $ele)
		{
			$image = $ele['abspath'];
			$basename = $ele['basename'];
			
			if ($gdim->rotate($image, $image, $angle))
			{
				$text .= $basename.': '.AUTOGAL_LANG_ADMIN_EDIT_53." (".$ele['ahref'].">".AUTOGAL_LANG_ADMIN_EDIT_50."</a>)<br >";
				AutoGal_AddAdminLog("ImageRotate", AUTOGAL_LANG_ADMIN_FUNCTIONS_L79." \"".$image."\" $angle ".AUTOGAL_LANG_ADMIN_EDIT_78);
			}
			else
			{
				$text .= $basename.": <font color='red'>".AUTOGAL_LANG_ADMIN_EDIT_54."<font> - ".$gdim->lastError()."<br />";
			}
			
			if (!$info['imgthumbunavail'])
			{
				$image = $ele['imgthumbpath'];
				$basename = basename($image);
				
				if ($gdim->rotate($image, $image, $angle))
				{
					$text .= $basename.': '.AUTOGAL_LANG_ADMIN_EDIT_53."<br />";
				}
				else
				{
					$text .= $basename.": <font color='red'>".AUTOGAL_LANG_ADMIN_EDIT_54."<font> - ".$gdim->lastError()."<br />";
				}
			}
		}
		
		$text .= "<br />
		[<a href=\"".$eleInfo['backlink']."\">".AUTOGAL_LANG_ADMIN_EDIT_3.$eleInfo['filetypetitle']." '".($eleInfo['title'] ? $eleInfo['title'] : AUTOGAL_ROOTNAME)."'</a>]<br />
		</div>";
		
		return $text;
	}
	
	$text = "
	<br />
	<div style='text-align:center'>
	<b>".AUTOGAL_LANG_ADMIN_EDIT_51."</b><br />
	<br />
	<select name='ag_angle' class='tbox'>
	<option value='90'>90</option>
	<option value='180'>180</option>
	<option value='270'>270</option>
	</select><br />
	<br />
	<table class='border' style='width:97%'>
	<tr>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_46."</th>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_39."</th>
	</tr>
	$imageTable
	</table>
	<br />
	<input type='submit' class='button' name='ag_doit' value='".AUTOGAL_LANG_ADMIN_EDIT_52."'>
	<input type='button' class='button' value='".AUTOGAL_LANG_ADMIN_EDIT_12."' onclick='javascript:history.go(-1)'>
	</div>";
	
	return $text;
}

function AutoGal_PageSetViewSize($eleInfo, $eles)
{
	global $pref;
	
	foreach ($eles as $ele)
	{
		if ($ele['isgallery']) continue;
		
		$okEles[] = $ele;
		
		$imageTable .= "
		<tr>
			<td class='forumheader3' style='text-align:center'>".
				($ele['imgthumbhtml'] ? $ele['ahref'].">".$ele['imgthumbhtml']."<br />" : '')."
			</td>
			<td class='forumheader3' style='text-align:center'>
				".$ele['fulltitle']."
			</td>
		</tr>";
	}
	
	if (!$imageTable)
	{
		$text = " 
		<div style='text-align:center'>
		<br />
		".AUTOGAL_LANG_ADMIN_EDIT_80."<br />
		<br />
		<input type='button' class='button' value='".AUTOGAL_LANG_ADMIN_EDIT_12."' onclick='javascript:history.go(-1)'>
		</div>";
		
		return $text;
	}
	
	if ($_POST['ag_doit'])
	{
		$width = $_POST['ag_viewwidth'];
		$height = $_POST['ag_viewheight'];
		
		$widthMsg = ($width ? $width : AUTOGAL_LANG_ADMIN_EDIT_87);
		$heightMsg = ($height ? $height : AUTOGAL_LANG_ADMIN_EDIT_87);
		
		if (!preg_match("/^[0-9]*$/", $width))
		{
			$text .= "<div style='text-align:center'><br />".AUTOGAL_LANG_ADMIN_EDIT_84."<br /></div>";
		}
		else if (!preg_match("/^[0-9]*$/", $height))
		{
			$text .= "<div style='text-align:center'><br />".AUTOGAL_LANG_ADMIN_EDIT_85."<br /></div>";
		}
		else
		{
			$text .= "<div style='text-align:left'>";
	
			foreach ($okEles as $ele)
			{
				$ele = AutoGal_GetElementInfo($ele['element'], true);
				if ($width) 
				{
					$ele['viewwidth'] = $width;
				}
				else
				{
					unset($ele['viewwidth']);
				}
				
				if ($height) 
				{
					$ele['viewheight'] = $height;
				}
				else
				{
					unset($ele['viewheight']);
				}
					
				if (!AutoGal_SetElementInfo($ele, 0, $errMsg))
				{
					$text .= $ele['filetypetitle']." \"".$ele['title']."\": <b>".AUTOGAL_LANG_ADMIN_FUNCTIONS_L48."</b> ".AUTOGAL_LANG_ADMIN_FUNCTIONS_L116." ($errMsg)<br />";
				}
				else
				{
					$text .=  $ele['filetypetitle']." \"".$ele['title']."\": ".str_replace("[WIDTH]", $widthMsg, str_replace("[HEIGHT]", $heightMsg, AUTOGAL_LANG_ADMIN_EDIT_86))."<br />";
				}
			}
		
			$text .= "<br />
			[<a href=\"".$eleInfo['backlink']."\">".AUTOGAL_LANG_ADMIN_EDIT_3.$eleInfo['filetypetitle']." '".($eleInfo['title'] ? $eleInfo['title'] : AUTOGAL_ROOTNAME)."'</a>]<br />
			</div>";
		
			return $text;
		}
	}
	
	$text .= "
	<br />
	<div style='text-align:center'>
	<b>".AUTOGAL_LANG_ADMIN_EDIT_81."</b><br />
	<span class='smalltext'>".AUTOGAL_LANG_ADMIN_EDIT_82."</span><br />
	<br />
	<input type='text' class='tbox' name='ag_viewwidth' size='5'> x <input type='text' class='tbox' name='ag_viewheight' size='5'><br />
	<br />
	<table class='border' style='width:97%'>
	<tr>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_46."</th>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_39."</th>
	</tr>
	$imageTable
	</table>
	<br />
	<input type='submit' class='button' name='ag_doit' value='".AUTOGAL_LANG_ADMIN_EDIT_83."'>
	<input type='button' class='button' value='".AUTOGAL_LANG_ADMIN_EDIT_12."' onclick='javascript:history.go(-1)'>
	</div>";
	
	return $text;
}

function AutoGal_PageClearMeta($eleInfo, $eles)
{
	global $pref;
	
	foreach ($eles as $ele)
	{
		$thumbImg = ($ele['isgallery'] ? $ele['defimghtml'] : $ele['imgthumbhtml']."<br />");
	
		$eleListTable .= "
		<tr>
			<td class='forumheader3' style='text-align:center'>".
				$ele['filetypetitle']."
			</td>
			<td class='forumheader3' style='text-align:center'>".
				($thumbImg ? $ele['ahref'].">".$thumbImg : '').
				$ele['ahref'].">".$ele['title']."</a>
			</td>
			<td class='forumheader3' style='text-align:center'>
				".$ele['fulltitle']."
			</td>
		</tr>";
	}
	
	if ($_POST['ag_doit'])
	{
		$clearComments = $_POST['ag_clearcomments'];
		$clearRatings = $_POST['ag_clearratings'];
		$clearScores = $_POST['ag_clearscores'];
		$clearViewHits = $_POST['ag_clearviewhits'];
		$clearEmailHits = $_POST['ag_clearemailhits'];
		$clearDesc = $_POST['ag_cleardescription'];
		
		$cleared = array();
		if ($clearComments)  array_push($cleared, AUTOGAL_LANG_ADMIN_EDIT_89);
		if ($clearRatings)   array_push($cleared, AUTOGAL_LANG_ADMIN_EDIT_90);
		if ($clearScores)    array_push($cleared, AUTOGAL_LANG_ADMIN_EDIT_91);
		if ($clearDesc)      array_push($cleared, AUTOGAL_LANG_ADMIN_EDIT_93);
		if ($clearViewHits)  array_push($cleared, AUTOGAL_LANG_ADMIN_EDIT_94);
		if ($clearEmailHits) array_push($cleared, AUTOGAL_LANG_ADMIN_EDIT_95);
			
		if (count($cleared) <= 0)
		{
			$text .= "<div style='text-align:center'><br />".AUTOGAL_LANG_ADMIN_EDIT_96."<br /></div>";
		}
		else
		{
			foreach ($eles as $ele)
			{
				$ele = AutoGal_GetElementInfo($ele['element'], true);
				
				if ($clearComments)  unset($ele['comments']);
				if ($clearRatings)   unset($ele['ratings']);
				if ($clearScores)    unset($ele['arcade']['topscores']);
				if ($clearViewHits)  unset($ele['viewhits']);
				if ($clearEmailHits) unset($ele['emailhits']);
				if ($clearDesc)      unset($ele['description']);
					
				if (!AutoGal_SetElementInfo($ele, 0, $errMsg))
				{
					$text .= $ele['filetypetitle']." \"".$ele['title']."\": <b>".AUTOGAL_LANG_ADMIN_FUNCTIONS_L48."</b> ".AUTOGAL_LANG_ADMIN_FUNCTIONS_L116." ($errMsg)<br />";
				}
				else
				{
					$text .=  $ele['filetypetitle']." \"".$ele['title']."\": ".str_replace("[CLEARED]", implode(", ", $cleared), AUTOGAL_LANG_ADMIN_EDIT_97)."<br />";
				}
			}
	
			$text .= "<br />
			[<a href=\"".$eleInfo['backlink']."\">".AUTOGAL_LANG_ADMIN_EDIT_3.$eleInfo['filetypetitle']." '".($eleInfo['title'] ? $eleInfo['title'] : AUTOGAL_ROOTNAME)."'</a>]<br />
			</div>";
		
			return $text;
		}
	}
	
	$text .= "
	<br />
	<div style='text-align:center'>
	<b>".AUTOGAL_LANG_ADMIN_EDIT_88."</b><br />
	<br />
	<table class='border'>
	<tr>
		<td class='forumheader3' style='text-align:left'>".AUTOGAL_LANG_ADMIN_EDIT_89."</td><td class='forumheader3'><input type='checkbox' name='ag_clearcomments'></td>
		<td class='forumheader3' style='text-align:left'>".AUTOGAL_LANG_ADMIN_EDIT_90."</td><td class='forumheader3'><input type='checkbox' name='ag_clearratings'></td>
	</tr>
	<tr>
	<tr>
		<td class='forumheader3' style='text-align:left'>".AUTOGAL_LANG_ADMIN_EDIT_91."</td><td class='forumheader3'><input type='checkbox' name='ag_clearscores'></td>
		<td class='forumheader3' style='text-align:left'>".AUTOGAL_LANG_ADMIN_EDIT_93."</td><td class='forumheader3'><input type='checkbox' name='ag_cleardescription'></td>
	</tr>
	<tr>
		<td class='forumheader3' style='text-align:left'>".AUTOGAL_LANG_ADMIN_EDIT_94."</td><td class='forumheader3'><input type='checkbox' name='ag_clearviewhits'></td>
		<td class='forumheader3' style='text-align:left'>".AUTOGAL_LANG_ADMIN_EDIT_95."</td><td class='forumheader3'><input type='checkbox' name='ag_clearemailhits'></td>
	</tr>
	</table>
	<br />
	<table class='border' style='width:97%'>
	<tr>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_5."</th>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_6."</th>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_39."</th>
	</tr>
	$eleListTable
	</table>
	<br />
	<input type='submit' class='button' name='ag_doit' value='".AUTOGAL_LANG_ADMIN_EDIT_92."'>
	<input type='button' class='button' value='".AUTOGAL_LANG_ADMIN_EDIT_12."' onclick='javascript:history.go(-1)'>
	</div>";
	
	return $text;
}

function AutoGal_AutoWatermarking($eleInfo, $eles)
{
	foreach ($eles as $ele)
	{
		if ($ele['type'] != 'Gallery') continue;
		$element = $ele['element'];
		
		$isOn = 1;
		if (file_exists($ele['abspath']."/.htaccess"))
		{
			$isOn = 0;
		}
		
		$wmOn[$element] = $isOn;
		$okEles[] = $ele;
		
		$galTable .= "
		<tr>
			<td class='forumheader3' style='text-align:center'>".
				($ele['defimghtml'] ? $ele['ahref'].">".$ele['defimghtml'] : '').
				$ele['ahref'].">".$ele['title']."</a>
			</td>
			<td class='forumheader3' style='text-align:center'>
				<input type='radio' value='yes' name=\"ag_awm_".str_replace('.', '_', rawurlencode($element))."\"".($isOn ? " checked='checked'" : '').">".AUTOGAL_LANG_ADMIN_EDIT_65." 
				<input type='radio' value='no' name=\"ag_awm_".str_replace('.', '_', rawurlencode($element))."\"".(!$isOn ? " checked='checked'" : '').">".AUTOGAL_LANG_ADMIN_EDIT_66."
			</td>
		</tr>";
	}
	
	if ($_POST['ag_doit'])
	{
		foreach ($okEles as $ele)
		{
			$element = $ele['element'];
			$postVar = "ag_awm_".str_replace('.', '_', rawurlencode($element));
			$turnAWMon = (strtolower($_POST[$postVar]) == 'yes' ? 1 : 0);
			$prevSetting = $wmOn[$element];
		
			if ($turnAWMon != $prevSetting)
			{
				$htAccess = $ele['abspath']."/.htaccess";
				if ($turnAWMon)
				{
					if (!unlink($htAccess))
					{
						$text .= $ele['title'].': '.str_replace("[FILE]", $htAccess, AUTOGAL_LANG_ADMIN_EDIT_69)."<br />";
					}
					else
					{
						$text .= $ele['title'].': '.str_replace("[FILE]", $htAccess, AUTOGAL_LANG_ADMIN_EDIT_70)."<br />";
						AutoGal_AddAdminLog("AutoWatermarking", AUTOGAL_LANG_ADMIN_FUNCTIONS_L79." \"".$ele['abspath']."\" ".AUTOGAL_LANG_ADMIN_EDIT_65);
					}
				}
				else
				{
					$HTACCESS = fopen($htAccess, "w+");
					if (!$HTACCESS)
					{
						$text .= $ele['title'].': '.str_replace("[FILE]", $htAccess, AUTOGAL_LANG_ADMIN_EDIT_71)."<br />";
					}
					else
					{
						$exts = explode('|', AUTOGAL_IMAGEEXTS);
						
						foreach ($exts as $ext)
						{
							fwrite($HTACCESS, "RemoveHandler .$ext\n");
						}
						
						fclose($HTACCESS);
						
						$text .= $ele['title'].': '.str_replace("[FILE]", $htAccess, AUTOGAL_LANG_ADMIN_EDIT_72)."<br />";
						AutoGal_AddAdminLog("AutoWatermarking", AUTOGAL_LANG_ADMIN_FUNCTIONS_L79." \"".$ele['abspath']."\" ".AUTOGAL_LANG_ADMIN_EDIT_66);
						
						if (chmod($htAccess, octdec(AUTOGAL_PERMSHTACCESS)))
						{
							$text .= $ele['title'].': '.str_replace("[PERMS]", AUTOGAL_PERMSHTACCESS, str_replace("[FILE]", $htAccess, AUTOGAL_LANG_ADMIN_EDIT_76))."<br />";
						}
						else
						{
							$text .= $ele['title'].': '.str_replace("[PERMS]", AUTOGAL_PERMSHTACCESS, str_replace("[FILE]", $htAccess, AUTOGAL_LANG_ADMIN_EDIT_77))."<br />";
						}
					}
				}
			}
		}
		
		if (!$text)
		{
			$text = AUTOGAL_LANG_ADMIN_EDIT_73."<br />";
		}
		
		$text .= "<br />
		[<a href=\"".$eleInfo['backlink']."\">".AUTOGAL_LANG_ADMIN_EDIT_3.$eleInfo['filetypetitle']." '".($eleInfo['title'] ? $eleInfo['title'] : AUTOGAL_ROOTNAME)."'</a>]<br />
		</div>";
			
		return $text;
	}
	
	if (!$galTable)
	{
		$text = " 
		<div style='text-align:center'>
		<br />
		".AUTOGAL_LANG_ADMIN_EDIT_64."<br />
		<br />
		<input type='button' class='button' value='".AUTOGAL_LANG_ADMIN_EDIT_12."' onclick='javascript:history.go(-1)'>
		</div>";
		
		return $text;
	}
	
	$text = "
	<br />
	<div style='text-align:center'>
	<b>".AUTOGAL_LANG_ADMIN_EDIT_75."</b><br />
	<span class='smalltext'>".AUTOGAL_LANG_ADMIN_EDIT_74."</span><br />
	<br />
	<table class='border' style='width:97%'>
	<tr>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_16."</th>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_67."</th>
	</tr>
	$galTable
	</table>
	<br />
	<input type='submit' class='button' name='ag_doit' value='".AUTOGAL_LANG_ADMIN_EDIT_68."'>
	<input type='button' class='button' value='".AUTOGAL_LANG_ADMIN_EDIT_12."' onclick='javascript:history.go(-1)'>
	</div>";
	
	return $text;
}

function AutoGal_PageUploadThumb($eleInfo, $eles)
{
	global $pref;
	
	foreach ($eles as $ele)
	{
		if ($ele['type'] == 'Gallery') continue;
		$element = $ele['element'];
		
		$okEles[] = $ele;
		
		$imageTable .= "
		<tr>
			<td class='forumheader3' style='text-align:center'>".
				($ele['imgthumbhtml'] ? $ele['ahref'].">".$ele['imgthumbhtml']."<br />" : '').
				$ele['ahref'].">".$ele['title']."</a>
			</td>
			<td class='forumheader3' style='text-align:center'>
				<input class='tbox' type='file' name=\"ag_file_".str_replace('.', '_', rawurlencode($element))."\">
			</td>
		</tr>";
	}
	
	if ($_POST['ag_doit'])
	{
		foreach ($eles as $ele)
		{
			$element = $ele['element'];
			$postVar = "ag_file_".str_replace('.', '_', rawurlencode($element));
			$uploadFile = $_FILES[$postVar]['name'];
			if (!$uploadFile) continue;
			
			$upBasename = basename($uploadFile);
			
			if (!AutoGal_IsImage($uploadFile))
			{
				$text .= "$upBasename ".AUTOGAL_LANG_ADMIN_EDIT_59."<br />";
			}
			else
			{
				$pathInfo = pathinfo($uploadFile);
				$thumbPath = AutoGal_GetFileThumb($ele['abspath'], true, strtolower($pathInfo['extension']));
				$thBasename = basename($thumbPath);

				list($uploadOK, $msg) = AutoGal_UploadFile($postVar, $thumbPath);
				
				if ($uploadOK)
				{
					$text .= "$upBasename: ".str_replace('[PATH]', $thumbPath, AUTOGAL_LANG_ADMIN_EDIT_60)."<br />";
					AutoGal_AddAdminLog("ThumbUploaded", AUTOGAL_LANG_ADMIN_FUNCTIONS_L79." \"$thumbPath\".");
					
					if (AUTOGAL_AUTOTHUMB)
					{
						$imageStats = getimagesize($thumbPath);
						
						if (($imageStats[0] > AUTOGAL_THUMBWIDTH)||($imageStats[1] > AUTOGAL_THUMBHEIGHT))
						{
							$error = AutoGal_ResizeImage($thumbPath, $thumbPath, AUTOGAL_THUMBWIDTH, AUTOGAL_THUMBHEIGHT);
							
							if ($error)
							{
								$text .= "$thBasename: <font color='red'><b>".AUTOGAL_LANG_ADMIN_EDIT_61."</b></font>- $error<br />";
							}
							else
							{
								$text .= "$thBasename: ".AUTOGAL_LANG_ADMIN_EDIT_63."<br />";
							}
						}
					}
				}
				else
				{
					$text .= "$upBasename: <font color='red'><b>".AUTOGAL_LANG_ADMIN_EDIT_61."</b></font> - $msg<br />";
				}
			}
		}
		
		$text .= "<br />
		[<a href=\"".$eleInfo['backlink']."\">".AUTOGAL_LANG_ADMIN_EDIT_3.$eleInfo['filetypetitle']." '".($eleInfo['title'] ? $eleInfo['title'] : AUTOGAL_ROOTNAME)."'</a>]<br />
		</div>";
			
		return $text;
	}
	
	if (!$imageTable)
	{
		$text = " 
		<div style='text-align:center'>
		<br />
		".AUTOGAL_LANG_ADMIN_EDIT_55."<br />
		<br />
		<input type='button' class='button' value='".AUTOGAL_LANG_ADMIN_EDIT_12."' onclick='javascript:history.go(-1)'>
		</div>";
		
		return $text;
	}
	
	$text = "
	<br />
	<div style='text-align:center'>
	<table class='border' style='width:97%'>
	<tr>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_56."</th>
		<th class='forumheader'>".AUTOGAL_LANG_ADMIN_EDIT_57."</th>
	</tr>
	$imageTable
	</table>
	<br />
	<input type='submit' class='button' name='ag_doit' value='".AUTOGAL_LANG_ADMIN_EDIT_58."'>
	<input type='button' class='button' value='".AUTOGAL_LANG_ADMIN_EDIT_12."' onclick='javascript:history.go(-1)'>
	</div>";
	
	return $text;
}

?>