<?php
/*********************************************************************************************
 * e107 PLUGIN: Auto Gallery
 * VERSION:     2.xx
 * DESCRIPTION: A media/image gallery, where galleries are based on a directory structure. 
 *              Thumbnails are automatically generated through Imagemagick or GD.
 * WRITTEN BY:  Mr_Visible (www.cerebralsynergy.com)
 * DATE:        11/04/2007
 *
 * Released under the terms and conditions of the
 * GNU General Public License (http://gnu.org).
 ********************************************************************************************/
 
require_once(dirname(__FILE__)."/def.php");
require_once(dirname(__FILE__)."/language.php");

$startAG = microtime(true);

if (!AUTOGAL_SLIDESENABLE) {header("location:".AUTOGAL_AUTOGALLERY); exit;}

$startImg = stripslashes(rawurldecode(($_GET['first'] ? $_GET['first'] : $_POST['first'])));
$slideImg = stripslashes(rawurldecode(($_GET['slide'] ? $_GET['slide'] : $_POST['slide'])));
$status = ($_GET['status'] ? $_GET['status'] : $_POST['status']);
$changeTime = ($_GET['chtime'] ? $_GET['chtime'] : $_POST['chtime']);
$repeatOn = (($_GET['repeat'] ? $_GET['repeat'] : $_POST['repeat']) ? 1 : 0);
$showFullImg = (($_GET['fullimg'] ? $_GET['fullimg'] : $_POST['fullimg']) ? 1 : 0);

$startImgInfo = AutoGal_GetElementInfo($startImg);
if ((!$startImgInfo)||(!$startImgInfo['isfile']))
{
	print "Invalid start element: ".htmlspecialchars($startImg);
	exit;
}

define("e_PAGETITLE", AUTOGAL_TITLE. " / " . AUTOGAL_LANG_SLIDESHOW_L1);

if ($status)
{
	$slideImgInfo = AutoGal_GetElementInfo($slideImg);
	if ((!$slideImgInfo)||(!$slideImgInfo['isfile']))
	{
		print "Invalid slide element: ".htmlspecialchars($slideImg);
		exit;
	}
	
	if (!preg_match("/^\d+$/", $changeTime))
	{
		print "Invalid change time: ".htmlspecialchars($changeTime);
		exit;
	}
	
	if ($startImgInfo['gallery'] != $slideImgInfo['gallery'])
	{
		print "Galleries do not match: ".htmlspecialchars($startImgInfo['gallery'])."/".htmlspecialchars($slideImgInfo['gallery']);
		exit;
	}

	if (($status == 2)&&(!$repeatOn)&&($startImgInfo['element'] == $slideImgInfo['element']))
	{
		print AutoGal_SlideShowEnd($startImgInfo);
	}
	else
	{
		print AutoGal_SlideShowNext($startImgInfo, $slideImgInfo, $changeTime, $repeatOn, $showFullImg);
	}
}
else
{
	print AutoGal_SlideShowStart($startImgInfo);
	
}

function AutoGal_SlideShowNext($startImgInfo, $slideImgInfo, $changeTime, $repeatOn, $showFullImg)
{
	$galleryInfo = AutoGal_GetElementInfo($startImgInfo['gallery']);
	
	$galEles = AutoGal_GetGalleryElements($galleryInfo['element']);
    $currImgIndex = AutoGal_GetImageIndex($slideImgInfo['element'], $galEles);
	
	if (($currImgIndex + 1) >= count($galEles['files']))
	{
		$nextImgIndex = 0;
	}
	else
	{
		$nextImgIndex = $currImgIndex + 1;
	}
	
	if ($startImgInfo['element'] != $slideImgInfo['element'])
	{
		$prevImgInfo = $galEles['files'][$currImgIndex - 1];
	}
	
	$nextImgInfo = $galEles['files'][$nextImgIndex];
	
	$prevURL = AUTOGAL_SLIDESHOW."?first=".rawurlencode($startImgInfo['element'])."&slide=".rawurlencode($prevImgInfo['element'])."&chtime=$changeTime&repeat=$repeatOn&status=2&fullimg=$showFullImg";
	$nextURL = AUTOGAL_SLIDESHOW."?first=".rawurlencode($startImgInfo['element'])."&slide=".rawurlencode($nextImgInfo['element'])."&chtime=$changeTime&repeat=$repeatOn&status=2&fullimg=$showFullImg";
			
	$title = "<h".AUTOGAL_TITLEHEADSTYLE.">".$slideImgInfo['title']."</h".AUTOGAL_TITLEHEADSTYLE.">";
	$subTitle = ($startImgInfo['subtitle'] ? $slideImgInfo['subtitle']."<br />" : '');
	$fileShow = AutoGal_FilePreviewHTML($slideImgInfo, $showFullImg, true, true);
	
    $prevFile = ($prevImgInfo ? "<input type='button' title=\"".$prevImgInfo['title']."\" class='button' value='".AUTOGAL_LANG_L8."' onclick='javascript:window.location.href=\"$prevURL\"' />" : "<input type='button' value='".AUTOGAL_LANG_L8."' class='button' disabled='disabled' />");
    $nextFile = ($nextImgInfo ? "<input type='button' title=\"".$nextImgInfo['title']."\" class='button' value='".AUTOGAL_LANG_L9."' onclick='javascript:window.location.href=\"$nextURL\"' />" : "<input type='button' value='".AUTOGAL_LANG_L9."' class='button' disabled='disabled' />");
	
	if (AUTOGAL_SLIDESNEWWINDOW)
	{
		$backLink = "<input type='button' class='button' value='".AUTOGAL_LANG_L25."' onClick='javascript:window.close()'>";
	}
	else
	{
		$backLink = "<input type='button' title=\"".AUTOGAL_LANG_L13.$galleryInfo['title']."\" class='button' value='".AUTOGAL_LANG_L11."' onclick='javascript:window.location.href=\"".$galleryInfo['backlink']."\"' />";
	}
	
	$fileText = "
	$title
	$subTitle
	$fileShow<br />
	$prevFile&#160;$backLink&#160;$nextFile";

	$text = AutoGal_GetNewWindowHeader(e_PAGETITLE, "<meta http-equiv=\"refresh\" content=\"$changeTime; URL=$nextURL\">", AUTOGAL_SLIDEBODYCLASS, AUTOGAL_SLIDEBODYSTYLE);
	$text .= $fileText;
	$text .= AutoGal_GetNewWindowFooter();
	
	return $text;
}

function AutoGal_SlideShowEnd($startImgInfo)
{
	$galleryInfo = AutoGal_GetElementInfo($startImgInfo['gallery']);
	
	$text = AutoGal_GetNewWindowHeader(e_PAGETITLE, "", AUTOGAL_SLIDEBODYCLASS, AUTOGAL_SLIDEBODYSTYLE);
	$text .= "<br />";
	$text .= "<h2>".AUTOGAL_LANG_SLIDESHOW_L14."</h2><br />";
	
	if (AUTOGAL_SLIDESNEWWINDOW)
	{
		$text .= "<input type='button' class='button' value='".AUTOGAL_LANG_SLIDESHOW_L16."' onClick='javascript:window.close()'><br />";
	}
	else
	{
		$text .= "<input type='button' class='button' value='".AUTOGAL_LANG_SLIDESHOW_L15."' onClick='javascript:window.location.href=\"".AUTOGAL_AUTOGALLERY."?show=".urlencode($galleryInfo['element'])."\"'><br />";
	}
	
	$text .= "<br />";
	$slideShowURL = AUTOGAL_SLIDESHOW."?first=".htmlspecialchars($startImgInfo['element']);
	$text .= "<input type='button' class='button' value='".AUTOGAL_LANG_SLIDESHOW_L17."' onClick='javascript:window.location.href=\"$slideShowURL\"'><br />";
	
	$text .= AutoGal_GetNewWindowFooter();
	
	return $text;
}

function AutoGal_SlideShowStart($startImgInfo)
{
	$galleryInfo = AutoGal_GetElementInfo($startImgInfo['gallery']);
	
	$text = AutoGal_GetNewWindowHeader(e_PAGETITLE, "", AUTOGAL_SLIDEBODYCLASS, AUTOGAL_SLIDEBODYSTYLE);
	
	if (AUTOGAL_SLIDESNEWWINDOW)
	{
		$backLink = "<input type='button' class='button' value='".AUTOGAL_LANG_L25."' onClick='javascript:window.close()'>";
	}
	else
	{
		$backLink = "<input type='button' title=\"".AUTOGAL_LANG_L13.$galleryInfo['title']."\" class='button' value='".AUTOGAL_LANG_L11."' onclick='javascript:window.location.href=\"".$galleryInfo['backlink']."\"' />";
	}
	
	$text .= "
	<br />
	<form method='GET'>
	<table class='fborder' colspan='2'>
	<tr>
		<td colspan='2' class='forumheader'><b>".AUTOGAL_LANG_SLIDESHOW_L1."</b></td>
	</tr>
	<tr>
		<td style='width:50%' class='forumheader3'>".AUTOGAL_LANG_SLIDESHOW_L3."</td>
		<td style='width:50%' class='forumheader3'><a href=\"".$galleryInfo['backlink']."\">".$galleryInfo['title']."</a></td>
	</tr>
	<tr>
		<td style='width:50%' class='forumheader3'>".AUTOGAL_LANG_SLIDESHOW_L4."</td>
		<td style='width:50%;text-align:center' class='forumheader3'>
			<a href=\"".$startImgInfo['backlink']."\">".$startImgInfo['imgthumbhtml']."</a><br />
			<a href=\"".$startImgInfo['backlink']."\">".$startImgInfo['title']."</a>
		</td>
	</tr>
	<tr>
		<td style='width:50%' class='forumheader3'>".AUTOGAL_LANG_SLIDESHOW_L5."</td>
		<td style='width:50%' class='forumheader3'>
			<select name='chtime' class='tbox'>
			<option value='5'>".str_replace("[TIME]", 5, AUTOGAL_LANG_SLIDESHOW_L9)."</option>
			<option value='10'>".str_replace("[TIME]", 10, AUTOGAL_LANG_SLIDESHOW_L9)."</option>
			<option value='15'>".str_replace("[TIME]", 15, AUTOGAL_LANG_SLIDESHOW_L9)."</option>
			<option value='20'>".str_replace("[TIME]", 20, AUTOGAL_LANG_SLIDESHOW_L9)."</option>
			<option value='30'>".str_replace("[TIME]", 30, AUTOGAL_LANG_SLIDESHOW_L9)."</option>
			<option value='60'>".str_replace("[TIME]", 1, AUTOGAL_LANG_SLIDESHOW_L10)."</option>
			<option value='90'>".str_replace("[TIME]", 1.5, AUTOGAL_LANG_SLIDESHOW_L11)."</option>
			<option value='120'>".str_replace("[TIME]", 2, AUTOGAL_LANG_SLIDESHOW_L11)."</option>
			<option value='180'>".str_replace("[TIME]", 3, AUTOGAL_LANG_SLIDESHOW_L11)."</option>
			<option value='240'>".str_replace("[TIME]", 4, AUTOGAL_LANG_SLIDESHOW_L11)."</option>
			<option value='300'>".str_replace("[TIME]", 5, AUTOGAL_LANG_SLIDESHOW_L11)."</option>
			<option value='600'>".str_replace("[TIME]", 10, AUTOGAL_LANG_SLIDESHOW_L11)."</option>
			</select>
		</td>
	</tr>
	<tr>
		<td style='width:50%' class='forumheader3'>".AUTOGAL_LANG_SLIDESHOW_L7."</td>
		<td style='width:50%' class='forumheader3'><input type='checkbox' name='repeat' checked='checked'></td>
	</tr>
	<tr>
		<td style='width:50%' class='forumheader3'>".AUTOGAL_LANG_SLIDESHOW_L13."</td>
		<td style='width:50%' class='forumheader3'><input type='checkbox' name='fullimg'></td>
	</tr>
	<tr style='vertical-align:top'>
		<td colspan='2'  style='text-align:center' class='forumheader2'>
			<input class='button' type='submit' value='".AUTOGAL_LANG_SLIDESHOW_L12."'>&#160;$backLink 
		</td>
	</tr>
	<input type='hidden' name='first' value=\"".rawurlencode($startImgInfo['element'])."\">
	<input type='hidden' name='slide' value=\"".rawurlencode($startImgInfo['element'])."\">
	<input type='hidden' name='status' value=\"1\">
	</table>
	</form>";
	
	$text .= AutoGal_GetNewWindowFooter();
	
	return $text;
}

?>