<?php
/*********************************************************************************************
 * e107 PLUGIN: Auto Gallery
 * VERSION:     2.xx
 * DESCRIPTION: A very simple media gallery, where galleries are based on a directory
 *              structure. For the e107 CMS (http://e107.org)
 * WRITTEN BY:  Mr_Visible (www.cerebralsynergy.com)
 * DATE:        18/11/2006
 *
 * Released under the terms and conditions of the
 * GNU General Public License (http://gnu.org).
 ********************************************************************************************/

require_once(dirname(__FILE__)."/def.php");
require_once(dirname(__FILE__)."/language.php");
require_once(dirname(__FILE__)."/../../class2.php");

$selGallery = stripslashes(rawurldecode($_POST['gallery'] ? $_POST['gallery'] : $_GET['gallery']));
$absPath = AutoGal_GetAbsGalPath($selGallery);
$galAbsPath = AutoGal_GetAbsGalPath('');

define("e_PAGETITLE", AUTOGAL_TITLE . ' - '.AUTOGAL_LANG_UPLOAD_L20);
require_once(HEADERF);

if ($absPath != $galAbsPath)
{
	if (!(preg_match("/^".preg_quote($galAbsPath, '/')."/", $absPath)))
	{
		$text = "Invalid gallery selected: $selGallery!";
		$ns -> tablerender(AUTOGAL_TITLE . " - ".AUTOGAL_LANG_UPLOAD_L20, $text);
		if (AUTOGAL_SHOW_FOOTER){require_once(FOOTERF);}
		exit;
	}
	if (!file_exists($absPath))
	{
		$text = "Gallery $selGallery does not exist!";
		$ns -> tablerender(AUTOGAL_TITLE . " - ".AUTOGAL_LANG_UPLOAD_L20, $text);
		if (AUTOGAL_SHOW_FOOTER){require_once(FOOTERF);}
		exit;
	}
}

if ($_POST['ag_issubmited'])
{
    if (check_class(AutoGal_GetGalUserClass($selGallery, 'upload')))
	{
		$uploadType = 'direct';
	}
	elseif(check_class(AUTOGAL_REVUPLOADUC))
	{
		$uploadType = 'reviewed';
	}
		
	$msgs = '';
    for ($fileNum = 0; $fileNum < AUTOGAL_UPLOADNUMBER; $fileNum ++)
    {
        $uploadFile = $_FILES["ag_file_$fileNum"]['name'];
		$uploadThumb = $_FILES["ag_thumb_$fileNum"]['name'];
        
        if (!$uploadFile) continue;
        
        $uploadTitle = $_POST["ag_filetitle_$fileNum"];
        $imgPathInfo = pathinfo($uploadFile);
        
        $uploadFileNoExt = $imgPathInfo['basename'];
        $uploadFileNoExt = preg_replace("/\.(".$imgPathInfo['extension'].")$/i", '', $uploadFileNoExt);
        $uploadTitle = ($uploadTitle ? $uploadTitle : $uploadFileNoExt);
		        
		$uploadTitle = str_replace("\\'", "'", $uploadTitle);
        if (preg_match("/\/\\\*\<\>\|\:\"\?/", $uploadTitle))
        {
            $msgs .= "<li>".AUTOGAL_LANG_UPLOAD_L2."/\\*&lt;&gt;|:\"?</li>";
        }
		
		$uploadTitle = preg_replace("/^".AUTOGAL_THUMBPREFIX."/", "fun thumb rum", $uploadTitle);

        if (!preg_match("/^(".AUTOGAL_UPLOADEXTS.")$/i", $imgPathInfo['extension']))
        {
			$msgs .= "<li><b>$uploadFile</b> - <font color='red'><b>".AUTOGAL_LANG_UPLOAD_L25."</b></font> ".AUTOGAL_LANG_UPLOAD_L8.(str_replace('|', ', ', AUTOGAL_UPLOADEXTS))."</li>";
			continue;
		}
		
		if ($uploadThumb)
		{
			$thumbPathInfo = pathinfo($uploadThumb);
			if (!preg_match("/^(".AUTOGAL_IMAGEEXTS.")$/i", $thumbPathInfo['extension']))
			{
				$msgs .= "<li><b>$uploadFile</b> - <font color='red'><b>".AUTOGAL_LANG_UPLOAD_L25."</b></font> ".AUTOGAL_LANG_UPLOAD_L30.(str_replace('|', ', ', AUTOGAL_IMAGEEXTS))."</li>";
				continue;
			}
		}
		
		# GET THE USERNAME
		if (USER)
		{
			$username = USERNAME;
			$userID = USERID;
		}
		else
		{
			$username = $_SERVER['REMOTE_ADDR'];
			$userID = 0;
		}
			
		if ($uploadType == 'direct')
		{
			$uploadFile = "$uploadTitle.".$imgPathInfo['extension'];
			if ($uploadThumb) $thumbFile = AUTOGAL_THUMBPREFIX.$uploadTitle.'.'.$imgPathInfo['extension'].'.'.strtolower($thumbPathInfo['extension']);
			$uploadDirRel = AutoGal_GetAbsGalPath($selGallery);
			$chmodVal = AUTOGAL_PERMSGALMEDIA;
			$chmodXmlVal = AUTOGAL_PERMSGALXML;
		}
		else
		{
			$submitTag = '';
			if (!AUTOGAL_USEXMLMETA) $submitTag = '['.str_replace("[USERNAME]", $username, AUTOGAL_LANG_UPLOAD_L3).']';
			$uploadFile = $uploadTitle.$submitTag.'.'.$imgPathInfo['extension'];
			if ($uploadThumb) $thumbFile = AUTOGAL_THUMBPREFIX.$uploadTitle.$submitTag.'.'.$imgPathInfo['extension'].'.'.strtolower($thumbPathInfo['extension']);
			$uploadDirRel = AUTOGAL_UPLOADDIRABS;
			$chmodVal = AUTOGAL_PERMSUPLMEDIA;
			$chmodXmlVal = AUTOGAL_PERMSGALXML;
		}
		
		$uploadFile = str_replace(' ', '_', $uploadFile);
		$uploadFile = str_replace("\\", "", $uploadFile);
		$thumbFile = str_replace(' ', '_', $thumbFile);
		$thumbFile = str_replace("\\", "", $thumbFile);
			
		$uploadFileRel = "$uploadDirRel/$uploadFile";
		$uploadDir = $uploadDirRel; 
		$uploadPath = $uploadDir."/$uploadFile";
		if ($uploadThumb) $thumbPath = $uploadDir."/$thumbFile";
		
		#######################
		# CHECK UPLOAD FOLDER #
		#######################
		$uploadDirPermWarn = '<br />';
		if ((!AUTOGAL_CHMODWARNOFF)&&(ADMIN))
		{
			if ($uploadDirPermWarn = IsBadUploadDirPerms()) $ns -> tablerender("Upload Folder", $uploadPerms); 
		}
		
		$uploadRet = AutoGal_UploadFile("ag_file_$fileNum", $uploadPath);
		$uploadOK = $uploadRet[0];
		$uploadMsg = $uploadRet[1];
		
		if ($uploadOK)
		{
			chmod ($uploadPath, octdec($chmodVal));
			if ($pref['image_owner']) chown($uploadPath, $pref['image_owner']);
			
			$msgs .= "<li><b>$uploadTitle</b> - " . AUTOGAL_LANG_UPLOAD_L4 . " " .
			($uploadType == 'reviewed' ? AUTOGAL_LANG_UPLOAD_L5 : AUTOGAL_LANG_UPLOAD_L6."<a href=\"".AUTOGAL_AUTOGALLERY."?show=".rawurlencode($selGallery)."\">".($selGallery ? $selGallery : AutoGal_GetTitle(AUTOGAL_ROOTNAME, 1, 'title'))."</a>").'</li>';
			
			if ($uploadType == 'direct') AutoGal_AddAdminLog('DirectUpload', "File: $uploadPath");
			
			// DO XML STUFF
			if (AUTOGAL_USEXMLMETA)
			{
				$eleInfo = AutoGal_GetElementInfo(AutoGal_GetElement($uploadPath));
				$eleInfo['submitbyusername'] = $username;
				$eleInfo['submitbyuserid'] = $userID;
				$eleInfo['submitdate'] = time();
				$eleInfo['xmlfile'] = "$uploadPath.xml";
				$eleInfo['description'] = stripslashes($_POST["ag_filedesc_$fileNum"]);
				$eleInfo['suggestedgallery'] = rawurlencode($selGallery);
				
				if (!AutoGal_SetElementInfo($eleInfo, $chmodXmlVal, $errMsg))
				{
					$msgs .= "<li><b>$uploadTitle</b> - " . AUTOGAL_LANG_XML_L1." ($errMsg)</li>\n";
				}
			}
			
			if ($uploadThumb)
			{
				$uploadRet = AutoGal_UploadFile("ag_thumb_$fileNum", $thumbPath);
				$uploadOK = $uploadRet[0];
				$uploadMsg = $uploadRet[1];
				
				if ($uploadOK)
				{
					chmod ($uploadPath, octdec($chmodVal));
					if ($pref['image_owner']) chown($uploadPath, $pref['image_owner']);
					
					$msgs .= "<li><b>$thumbFile</b> - " . AUTOGAL_LANG_UPLOAD_L4."</li>";
					if ($uploadType == 'direct') AutoGal_AddAdminLog('DirectUpload', "ThumbFile: $thumbPath");
					
					if (AUTOGAL_AUTOTHUMB)
					{
						$thumbImgStats = getimagesize();
						if (($thumbImgStats[0] != AUTOGAL_THUMBWIDTH)||($thumbImgStats[0] != AUTOGAL_THUMBHEIGHT))
						{
							$error = AutoGal_ResizeImage($thumbPath, $thumbPath, AUTOGAL_THUMBWIDTH, AUTOGAL_THUMBHEIGHT);
							
							if ($error)
							{
								$msgs .= "<li><b>$thumbFile</b> - <font color='red'><b>".AUTOGAL_LANG_UPLOAD_L25."</b></font> $error</li>";
							}
							else
							{
								$msgs .= "<li><b>$uploadTitle</b> - " . str_replace("[WIDTH]", AUTOGAL_THUMBWIDTH, str_replace("[HEIGHT]", AUTOGAL_THUMBHEIGHT, AUTOGAL_LANG_UPLOAD_L37))."</li>\n";
							}
						}
					}
				}
				else
				{
					$msgs .= "<li><b>$thumbFile</b> - <font color='red'><b>".AUTOGAL_LANG_UPLOAD_L25."</b></font> $uploadMsg</li>";
				}
			}
		}
		else
		{
			$msgs .= "<li><b>$uploadFile</b> - <font color='red'><b>".AUTOGAL_LANG_UPLOAD_L25."</b></font> $uploadMsg</li>";
		}
    }
    
    if ($msgs)
    {
        $ns -> tablerender(AUTOGAL_TITLE, "<div style='text-align: left'>$uploadDirPermWarn<ul>$msgs</ul></div><br /><div style='text-align: center'><b>".AUTOGAL_LANG_UPLOAD_L29."</b></div>");    
    }
	
	if ($uploadType == 'direct')
	{
		AutoGal_ClearDirCache($selGallery);
	}
}

$reviewLink = AutoGal_GetReviewLink();

$botLinks = AutoGal_GetBotLinks(false);

# BUILD THE LIST OF GALLERIES USER CAN UPLOAD TO
$galSelect = "<select name='gallery' class='tbox'>";
$galleries = AutoGal_GalleryList('', true);
$atLeast1 = 0;
foreach ($galleries as $gallery)
{
	$galleryTitle = '';
	
	if (check_class(AutoGal_GetGalUserClass($gallery, 'upload')))
	{
		$galleryTitle = AutoGal_GetElementPathTitle($gallery, 0, ' -> ').AUTOGAL_LANG_UPLOAD_L33;
	}
	elseif(check_class(AUTOGAL_REVUPLOADUC))
	{
		$galleryTitle = AutoGal_GetElementPathTitle($gallery, 0, ' -> ').AUTOGAL_LANG_UPLOAD_L34;
	}
	
	if ($galleryTitle)
	{
		$galSelect .= "<option value=\"".rawurlencode($gallery)."\"".($selGallery == $gallery ? " selected='selected'" : '').">".$galleryTitle."</option>\n";
		$atLeast1 = 1;
	}
}
$galSelect .= "</select>";

# CHECK IF USER CAN UPLOAD TO AT LEAST 1 GALLERY
if (!$atLeast1)
{
	$text = "
	<div style='text-align:center'>
	<br />
	<b>".AUTOGAL_LANG_UPLOAD_L38."</b><br />
	<br />
	</div>";
	
	$ns -> tablerender(AUTOGAL_TITLE . " - ".AUTOGAL_LANG_UPLOAD_L20, $text);
	if (AUTOGAL_SHOW_FOOTER){require_once(FOOTERF);}
	exit;
}

$text = "
<script type='text/javascript'>
function ag_checkFileType(fileNum)
{
	var fileObj;
	var filePath;
	var fileExtI;
	var fileExt;
	var allowedExtRegex;
	var needThumbExtRegex;
	var thumbDivObj;
	
	fileObj = document.getElementById('ag_file_' + fileNum);
	thumbDivObj = document.getElementById('ag_thumbdiv_' + fileNum);
	filePath = fileObj.value;
	
	if (!filePath) return;
	
	fileExtI = filePath.lastIndexOf('.');
	fileExt = filePath.substr(fileExtI + 1);
	allowedExtRegex = /^(".AUTOGAL_UPLOADEXTS.")/i;
	
	needThumbExtRegex = /^(".AUTOGAL_EXTCLASS_MOVIE.'|'.AUTOGAL_EXTCLASS_AUDIO.'|'.AUTOGAL_EXTCLASS_ANIMATION.")/i;
		
	if (!fileExt.match(allowedExtRegex))
	{
		alert('".AUTOGAL_LANG_UPLOAD_L8.(str_replace('|', ', ', AUTOGAL_UPLOADEXTS))."');
		fileObj.value = '';
		return;
	}
	
	if (fileExt.match(needThumbExtRegex))
	{
		thumbDivObj.style.visibility = 'visible';
		thumbDivObj.style.position = 'relative';
		fileObj.style.visibility = 'visible';
		fileObj.style.position = 'relative';
	}
	else
	{
		thumbDivObj.style.visibility = 'hidden';
		thumbDivObj.style.position = 'absolute';
	}
}

function ag_checkThumbType(fileNum)
{
	var thumbObj;
	var filePath;
	var fileExtI;
	var fileExt;
	
	thumbObj = document.getElementById('ag_thumb_' + fileNum);
	filePath = thumbObj.value;
	
	if (!filePath) return;
	
	fileExtI = filePath.lastIndexOf('.');
	fileExt = filePath.substr(fileExtI + 1);
	allowedExtRegex = /^(".AUTOGAL_IMAGEEXTS.")/i;
	
	if (!fileExt.match(allowedExtRegex))
	{
		alert('".AUTOGAL_LANG_UPLOAD_L30.(str_replace('|', ', ', AUTOGAL_IMAGEEXTS))."');
		thumbObj.value = '';
		return;
	}
}
</script>
<div style='text-align:center'>
<form enctype='multipart/form-data' method='post'>
	<b>".AUTOGAL_LANG_UPLOAD_L35."</b><br />
	$galSelect<br />
	<br />
    ".AUTOGAL_LANG_UPLOAD_L8.(str_replace('|', ', ', AUTOGAL_UPLOADEXTS)).".<br />
    ".str_replace("[SIZE]", AUTOGAL_UPLOADMAXSIZE, AUTOGAL_LANG_UPLOAD_L32)."<br />
    <br />
    <input type='hidden' name='MAX_FILE_SIZE' value='".AUTOGAL_UPLOADMAXSIZE."'>
    <table class='border' width='97%'>
    <tr>
        <td class='forumheader'>".AUTOGAL_LANG_UPLOAD_L15."</td>
        <td class='forumheader'>".(AUTOGAL_USEXMLMETA ? AUTOGAL_LANG_UPLOAD_L24 : AUTOGAL_LANG_UPLOAD_L16)."</td>
        <td class='forumheader'>".AUTOGAL_LANG_UPLOAD_L17."</td>    
    </tr>";
    
    for ($fileNum = 0; $fileNum < AUTOGAL_UPLOADNUMBER; $fileNum ++)
    {
        $text .= "
        <tr>
            <td class='forumheader3'>".($fileNum + 1).".</td>
            <td class='forumheader3'>
				".
				(AUTOGAL_USEXMLMETA ? 
					AUTOGAL_LANG_UPLOAD_L16."<br />
					<input type='text' class='tbox' name='ag_filetitle_$fileNum' size='50'><br />
					<br />".
					AUTOGAL_LANG_UPLOAD_L23."<br />
					<textarea name='ag_filedesc_$fileNum' class='tbox' cols='60' rows='6'></textarea>"
				: 
					"<input type='text' class='tbox' name='ag_filetitle_$fileNum' size='50'>"
				)."
			</td>
            <td class='forumheader3'>
				<table>
				<tr>
					<td>
						<input class='tbox' name='ag_file_$fileNum' id='ag_file_$fileNum' type='file' onchange='javascript:ag_checkFileType($fileNum);'>
					</td>
				</tr>
				</table>
				<table id='ag_thumbdiv_$fileNum' style='visibility:hidden;position:absolute;text-align:center'>
				<tr>
					<td >
						<br /><br />
						".AUTOGAL_LANG_UPLOAD_L31."<br />
						<input class='tbox' type='file' name='ag_thumb_$fileNum' id='ag_thumb_$fileNum' onchange='javascript:ag_checkThumbType($fileNum)'>
					</td>
				</tr>
				</table>
			</td>    
        </tr>";
    }
    
    $text .= "
    </table>
    <br />
	<input type='hidden' name='ag_issubmited' value='1'>
    <input type='button' class='button' id='ag_submitimages' name='ag_submitimages' value='".AUTOGAL_LANG_UPLOAD_L18."' onclick=\"javascript:var btn = document.getElementById('ag_submitimages'); btn.disabled=true; btn.value='".AUTOGAL_LANG_UPLOAD_L39."'; form.submit()\">
    </form>
	".(count($botLinks) > 0 ? "<br />".implode(' ', $botLinks) : '')."
</div>";

$ns -> tablerender(AUTOGAL_TITLE . " - ".AUTOGAL_LANG_UPLOAD_L20, $text);
if (AUTOGAL_SHOW_FOOTER){require_once(FOOTERF);}

?>